#ifndef REP_ENGINE_REPLICA_H
#define REP_ENGINE_REPLICA_H

// This is an autogenerated file.
// Do not edit this file, any changes made will be lost the next time it is generated.

#include <QtCore/qobject.h>
#include <QtCore/qdatastream.h>
#include <QtCore/qvariant.h>
#include <QtCore/qmap.h>
#include <QtCore/qmetatype.h>

#include <QtRemoteObjects/qremoteobjectnode.h>
#include <QtRemoteObjects/qremoteobjectpendingcall.h>
#include <QtRemoteObjects/qremoteobjectreplica.h>

#include "temperature.h"

using namespace Qt::Literals::StringLiterals;

class EngineReplica : public QRemoteObjectReplica
{
    Q_OBJECT
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_TYPE, "Engine")
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_SIGNATURE, "a42bec2fbb4c1904edbce866d2b57b346622d016")
    Q_PROPERTY(int cylinders READ cylinders NOTIFY cylindersChanged)
    Q_PROPERTY(bool started READ started NOTIFY startedChanged)
    Q_PROPERTY(int rpm READ rpm WRITE setRpm NOTIFY rpmChanged)
    Q_PROPERTY(EngineType engineType READ engineType NOTIFY engineTypeChanged)

public:
    enum EngineType {
        GAS = 0,
        ELECTRIC = 1,
        HYBRID = 2,
    };
    Q_ENUM(EngineType)

public:
    EngineReplica() : QRemoteObjectReplica() { initialize(); }
    static void registerMetatypes()
    {
        static bool initialized = false;
        if (initialized)
            return;
        initialized = true;
        qRegisterMetaType<Temperature::Ptr>();
        qRegisterMetaType<Temperature>();
        qRegisterMetaType<EngineType>();
        qRegisterMetaType<QRemoteObjectPendingCall>();
        qRegisterMetaType<QRemoteObjectPendingReply<bool>>();
        if (!QMetaType::hasRegisteredConverterFunction<QRemoteObjectPendingReply<bool>, QRemoteObjectPendingCall>())
            QMetaType::registerConverter<QRemoteObjectPendingReply<bool>, QRemoteObjectPendingCall>();
        qRegisterMetaType<QRemoteObjectPendingReply<QString>>();
        if (!QMetaType::hasRegisteredConverterFunction<QRemoteObjectPendingReply<QString>, QRemoteObjectPendingCall>())
            QMetaType::registerConverter<QRemoteObjectPendingReply<QString>, QRemoteObjectPendingCall>();
        qRegisterMetaType<QRemoteObjectPendingReply<Temperature>>();
        if (!QMetaType::hasRegisteredConverterFunction<QRemoteObjectPendingReply<Temperature>, QRemoteObjectPendingCall>())
            QMetaType::registerConverter<QRemoteObjectPendingReply<Temperature>, QRemoteObjectPendingCall>();
        qRegisterMetaType<QRemoteObjectPendingReply<void>>();
        if (!QMetaType::hasRegisteredConverterFunction<QRemoteObjectPendingReply<void>, QRemoteObjectPendingCall>())
            QMetaType::registerConverter<QRemoteObjectPendingReply<void>, QRemoteObjectPendingCall>();

    }

private:
    EngineReplica(QRemoteObjectNode *node, const QString &name = QString())
        : QRemoteObjectReplica(ConstructWithNode)
    {
        initializeNode(node, name);
    }

    void initialize() override
    {
        EngineReplica::registerMetatypes();
        QVariantList properties;
        properties.reserve(4);
        properties << QVariant::fromValue(int(4));
        properties << QVariant::fromValue(bool());
        properties << QVariant::fromValue(int());
        properties << QVariant::fromValue(EngineType(GAS));
        QVariantList stored = retrieveProperties(QStringLiteral("Engine"), "a42bec2fbb4c1904edbce866d2b57b346622d016");
        if (!stored.isEmpty()) {
            properties[3] = stored.at(0);
        }
        setProperties(std::move(properties));
    }

public:
    ~EngineReplica() override {
        QVariantList persisted;
        persisted << propAsVariant(3);
        persistProperties(QStringLiteral("Engine"), "a42bec2fbb4c1904edbce866d2b57b346622d016", persisted);
    }

    int cylinders() const
    {
        const QVariant variant = propAsVariant(0);
        if (!variant.canConvert<int>()) {
            qWarning() << "QtRO cannot convert the property cylinders to type int";
        }
        return variant.value<int >();
    }

    bool started() const
    {
        const QVariant variant = propAsVariant(1);
        if (!variant.canConvert<bool>()) {
            qWarning() << "QtRO cannot convert the property started to type bool";
        }
        return variant.value<bool >();
    }

    int rpm() const
    {
        const QVariant variant = propAsVariant(2);
        if (!variant.canConvert<int>()) {
            qWarning() << "QtRO cannot convert the property rpm to type int";
        }
        return variant.value<int >();
    }

    void setRpm(int rpm)
    {
        static int __repc_index = EngineReplica::staticMetaObject.indexOfProperty("rpm");
        QVariantList __repc_args;
        __repc_args << QVariant::fromValue(rpm);
        send(QMetaObject::WriteProperty, __repc_index, __repc_args);
    }

    EngineType engineType() const
    {
        const QVariant variant = propAsVariant(3);
        if (!variant.canConvert<EngineType>()) {
            qWarning() << "QtRO cannot convert the property engineType to type EngineType";
        }
        return variant.value<EngineType >();
    }


Q_SIGNALS:
    void startedChanged(bool started);
    void rpmChanged(int rpm);
    void engineTypeChanged(EngineReplica::EngineType engineType);
    void cylindersChanged(int cylinders);

public Q_SLOTS:
    void pushStarted(bool started)
    {
        static int __repc_index = EngineReplica::staticMetaObject.indexOfSlot("pushStarted(bool)");
        QVariantList __repc_args;
        __repc_args << QVariant::fromValue(started);
        send(QMetaObject::InvokeMetaMethod, __repc_index, __repc_args);
    }
    void pushEngineType(EngineReplica::EngineType engineType)
    {
        static int __repc_index = EngineReplica::staticMetaObject.indexOfSlot("pushEngineType(EngineReplica::EngineType)");
        QVariantList __repc_args;
        __repc_args << QVariant::fromValue(engineType);
        send(QMetaObject::InvokeMetaMethod, __repc_index, __repc_args);
    }
    QRemoteObjectPendingReply<bool> start()
    {
        static int __repc_index = EngineReplica::staticMetaObject.indexOfSlot("start()");
        QVariantList __repc_args;
        return QRemoteObjectPendingReply<bool>(sendWithReply(QMetaObject::InvokeMetaMethod, __repc_index, __repc_args));
    }
    void increaseRpm(int deltaRpm)
    {
        static int __repc_index = EngineReplica::staticMetaObject.indexOfSlot("increaseRpm(int)");
        QVariantList __repc_args;
        __repc_args
            << QVariant::fromValue(deltaRpm)
        ;
        send(QMetaObject::InvokeMetaMethod, __repc_index, __repc_args);
    }
    void unnormalizedSignature(int a, int b)
    {
        static int __repc_index = EngineReplica::staticMetaObject.indexOfSlot("unnormalizedSignature(int,int)");
        QVariantList __repc_args;
        __repc_args
            << QVariant::fromValue(a)
            << QVariant::fromValue(b)
        ;
        send(QMetaObject::InvokeMetaMethod, __repc_index, __repc_args);
    }
    QRemoteObjectPendingReply<Temperature> temperature()
    {
        static int __repc_index = EngineReplica::staticMetaObject.indexOfSlot("temperature()");
        QVariantList __repc_args;
        return QRemoteObjectPendingReply<Temperature>(sendWithReply(QMetaObject::InvokeMetaMethod, __repc_index, __repc_args));
    }
    void setSharedTemperature(const Temperature::Ptr & sharedTemperature)
    {
        static int __repc_index = EngineReplica::staticMetaObject.indexOfSlot("setSharedTemperature(Temperature::Ptr)");
        QVariantList __repc_args;
        __repc_args
            << QVariant::fromValue(sharedTemperature)
        ;
        send(QMetaObject::InvokeMetaMethod, __repc_index, __repc_args);
    }
    QRemoteObjectPendingReply<QString> myTestString()
    {
        static int __repc_index = EngineReplica::staticMetaObject.indexOfSlot("myTestString()");
        QVariantList __repc_args;
        return QRemoteObjectPendingReply<QString>(sendWithReply(QMetaObject::InvokeMetaMethod, __repc_index, __repc_args));
    }
    void setMyTestString(QString value)
    {
        static int __repc_index = EngineReplica::staticMetaObject.indexOfSlot("setMyTestString(QString)");
        QVariantList __repc_args;
        __repc_args
            << QVariant::fromValue(value)
        ;
        send(QMetaObject::InvokeMetaMethod, __repc_index, __repc_args);
    }

private:
    friend class QT_PREPEND_NAMESPACE(QRemoteObjectNode);
};


#endif // REP_ENGINE_REPLICA_H
