#ifndef REP_ENGINE_SOURCE_H
#define REP_ENGINE_SOURCE_H

// This is an autogenerated file.
// Do not edit this file, any changes made will be lost the next time it is generated.

#include <QtCore/qobject.h>
#include <QtCore/qdatastream.h>
#include <QtCore/qvariant.h>
#include <QtCore/qmap.h>
#include <QtCore/qmetatype.h>

#include <QtRemoteObjects/qremoteobjectnode.h>
#include <QtRemoteObjects/qremoteobjectsource.h>

#include "temperature.h"

using namespace Qt::Literals::StringLiterals;

class EngineSource : public QObject
{
    Q_OBJECT
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_TYPE, "Engine")
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_SIGNATURE, "a42bec2fbb4c1904edbce866d2b57b346622d016")
    Q_PROPERTY(int cylinders READ cylinders CONSTANT)
    Q_PROPERTY(bool started READ started WRITE setStarted NOTIFY startedChanged)
    Q_PROPERTY(int rpm READ rpm WRITE setRpm NOTIFY rpmChanged)
    Q_PROPERTY(EngineType engineType READ engineType WRITE setEngineType NOTIFY engineTypeChanged)

public:
    enum EngineType {
        GAS = 0,
        ELECTRIC = 1,
        HYBRID = 2,
    };
    Q_ENUM(EngineType)

public:
    explicit EngineSource(QObject *parent = nullptr) : QObject(parent)
    {
        qRegisterMetaType<EngineType>();
        qRegisterMetaType<Temperature::Ptr>();
        qRegisterMetaType<Temperature>();

    }

public:
    ~EngineSource() override = default;

    virtual int cylinders() const = 0;
    virtual bool started() const = 0;
    virtual int rpm() const = 0;
    virtual EngineType engineType() const = 0;
    virtual void setStarted(bool started) = 0;
    virtual void setRpm(int rpm) = 0;
    virtual void setEngineType(EngineType engineType) = 0;

Q_SIGNALS:
    void startedChanged(bool started);
    void rpmChanged(int rpm);
    void engineTypeChanged(EngineSource::EngineType engineType);

public Q_SLOTS:
    virtual void pushStarted(bool started)
    {
        setStarted(started);
    }
    virtual void pushEngineType(EngineSource::EngineType engineType)
    {
        setEngineType(engineType);
    }
    virtual bool start() = 0;
    virtual void increaseRpm(int deltaRpm) = 0;
    virtual void unnormalizedSignature(int a, int b) = 0;
    virtual Temperature temperature() = 0;
    virtual void setSharedTemperature(const Temperature::Ptr & sharedTemperature) = 0;
    virtual QString myTestString() = 0;
    virtual void setMyTestString(QString value) = 0;

private:
    friend class QT_PREPEND_NAMESPACE(QRemoteObjectNode);
};

class EngineSimpleSource : public EngineSource
{
    Q_OBJECT

public:
    explicit EngineSimpleSource(int cylinders = 4, QObject *parent = nullptr) : EngineSource(parent)
    , m_cylinders(cylinders)
    , m_started()
    , m_rpm()
    , m_engineType(GAS)
    {
    }

public:
    ~EngineSimpleSource() override = default;

    int cylinders() const override { return m_cylinders; }
    bool started() const override { return m_started; }
    int rpm() const override { return m_rpm; }
    EngineType engineType() const override { return m_engineType; }
    void setStarted(bool started) override
    {
        if (started != m_started) {
            m_started = started;
            Q_EMIT startedChanged(m_started);
        }
    }
    void setRpm(int rpm) override
    {
        if (rpm != m_rpm) {
            m_rpm = rpm;
            Q_EMIT rpmChanged(m_rpm);
        }
    }
    void setEngineType(EngineType engineType) override
    {
        if (engineType != m_engineType) {
            m_engineType = engineType;
            Q_EMIT engineTypeChanged(m_engineType);
        }
    }

private:
    int m_cylinders;
    bool m_started;
    int m_rpm;
    EngineType m_engineType;
};

template <class ObjectType>
struct EngineSourceAPI : public SourceApiMap
{
    // You need to add this enum as well as Q_ENUM to your
    // QObject class in order to use .rep enums over QtRO for
    // non-repc generated QObjects.
    enum EngineType {
        GAS = 0,
        ELECTRIC = 1,
        HYBRID = 2,
    };
    EngineSourceAPI(ObjectType *object, const QString &name = QLatin1String("Engine"))
        : SourceApiMap(), m_name(name)
    {
        Q_UNUSED(object)
        m_enums[0] = 1;
        m_enums[1] = ObjectType::staticMetaObject.indexOfEnumerator("EngineType");
        m_properties[0] = 4;
        m_properties[1] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::cylinders, static_cast<int (QObject::*)()>(nullptr),"cylinders");
        m_properties[2] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::started, static_cast<bool (QObject::*)()>(nullptr),"started");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::startedChanged, static_cast<void (QObject::*)()>(nullptr));
        m_properties[3] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::rpm, static_cast<int (QObject::*)()>(nullptr),"rpm");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::setRpm, static_cast<void (QObject::*)(int)>(nullptr));
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::rpmChanged, static_cast<void (QObject::*)()>(nullptr));
        m_properties[4] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::engineType, static_cast<typename ObjectType::EngineType (QObject::*)()>(nullptr),"engineType");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::engineTypeChanged, static_cast<void (QObject::*)()>(nullptr));
        m_signals[0] = 3;
        m_signals[1] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::startedChanged, static_cast<void(QObject::*)(bool)>(nullptr),m_signalArgCount+0,&m_signalArgTypes[0]);
        m_signals[2] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::rpmChanged, static_cast<void(QObject::*)(int)>(nullptr),m_signalArgCount+1,&m_signalArgTypes[1]);
        m_signals[3] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::engineTypeChanged, static_cast<void(QObject::*)(typename ObjectType::EngineType)>(nullptr),m_signalArgCount+2,&m_signalArgTypes[2]);
        m_methods[0] = 9;
        m_methods[1] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::pushStarted, static_cast<void (QObject::*)(bool)>(nullptr),"pushStarted(bool)",m_methodArgCount+0,&m_methodArgTypes[0]);
        m_methods[2] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::pushEngineType, static_cast<void (QObject::*)(typename ObjectType::EngineType)>(nullptr),"pushEngineType(EngineType)",m_methodArgCount+1,&m_methodArgTypes[1]);
        m_methods[3] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::start, static_cast<void (QObject::*)()>(nullptr),"start()",m_methodArgCount+2,&m_methodArgTypes[2]);
        m_methods[4] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::increaseRpm, static_cast<void (QObject::*)(int)>(nullptr),"increaseRpm(int)",m_methodArgCount+3,&m_methodArgTypes[3]);
        m_methods[5] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::unnormalizedSignature, static_cast<void (QObject::*)(int,int)>(nullptr),"unnormalizedSignature(int,int)",m_methodArgCount+4,&m_methodArgTypes[4]);
        m_methods[6] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::temperature, static_cast<void (QObject::*)()>(nullptr),"temperature()",m_methodArgCount+5,&m_methodArgTypes[5]);
        m_methods[7] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::setSharedTemperature, static_cast<void (QObject::*)(Temperature::Ptr)>(nullptr),"setSharedTemperature(Temperature::Ptr)",m_methodArgCount+6,&m_methodArgTypes[6]);
        m_methods[8] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::myTestString, static_cast<void (QObject::*)()>(nullptr),"myTestString()",m_methodArgCount+7,&m_methodArgTypes[7]);
        m_methods[9] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::setMyTestString, static_cast<void (QObject::*)(QString)>(nullptr),"setMyTestString(QString)",m_methodArgCount+8,&m_methodArgTypes[8]);
    }

    QString name() const override { return m_name; }
    QString typeName() const override { return QStringLiteral("Engine"); }
    int enumCount() const override { return m_enums[0]; }
    int propertyCount() const override { return m_properties[0]; }
    int signalCount() const override { return m_signals[0]; }
    int methodCount() const override { return m_methods[0]; }
    int sourceEnumIndex(int index) const override
    {
        if (index < 0 || index >= m_enums[0] || index + 1 >= int(std::size(m_enums)))
            return -1;
        return m_enums[index+1];
    }
    int sourcePropertyIndex(int index) const override
    {
        if (index < 0 || index >= m_properties[0] || index + 1 >= int(std::size(m_properties)))
            return -1;
        return m_properties[index+1];
    }
    int sourceSignalIndex(int index) const override
    {
        if (index < 0 || index >= m_signals[0] || index + 1 >= int(std::size(m_signals)))
            return -1;
        return m_signals[index+1];
    }
    int sourceMethodIndex(int index) const override
    {
        if (index < 0 || index >= m_methods[0] || index + 1 >= int(std::size(m_methods)))
            return -1;
        return m_methods[index+1];
    }
    int signalParameterCount(int index) const override
    {
        if (index < 0 || index >= m_signals[0])
            return -1;
        return m_signalArgCount[index];
    }
    int signalParameterType(int sigIndex, int paramIndex) const override
    {
        if (sigIndex < 0 || sigIndex >= m_signals[0] || paramIndex < 0 || paramIndex >= m_signalArgCount[sigIndex])
            return -1;
        return m_signalArgTypes[sigIndex][paramIndex];
    }
    int methodParameterCount(int index) const override
    {
        if (index < 0 || index >= m_methods[0])
            return -1;
        return m_methodArgCount[index];
    }
    int methodParameterType(int methodIndex, int paramIndex) const override
    {
        if (methodIndex < 0 || methodIndex >= m_methods[0] || paramIndex < 0 || paramIndex >= m_methodArgCount[methodIndex])
            return -1;
        return m_methodArgTypes[methodIndex][paramIndex];
    }
    int propertyIndexFromSignal(int index) const override
    {
        switch (index) {
        case 0: return m_properties[2];
        case 1: return m_properties[3];
        case 2: return m_properties[4];
        }
        return -1;
    }
    int propertyRawIndexFromSignal(int index) const override
    {
        switch (index) {
        case 0: return 1;
        case 1: return 2;
        case 2: return 3;
        }
        return -1;
    }
    const QByteArray signalSignature(int index) const override
    {
        switch (index) {
        case 0: return QByteArrayLiteral("startedChanged(bool)");
        case 1: return QByteArrayLiteral("rpmChanged(int)");
        case 2: return QByteArrayLiteral("engineTypeChanged($1)").replace("$1", QtPrivate::qtro_enum_signature<ObjectType>("EngineType"));
        }
        return QByteArrayLiteral("");
    }
    QByteArrayList signalParameterNames(int index) const override
    {
        if (index < 0 || index >= m_signals[0] || index + 1 >= int(std::size(m_signals)))
            return QByteArrayList();
        return ObjectType::staticMetaObject.method(m_signals[index + 1]).parameterNames();
    }
    const QByteArray methodSignature(int index) const override
    {
        switch (index) {
        case 0: return QByteArrayLiteral("pushStarted(bool)");
        case 1: return QByteArrayLiteral("pushengineType($1)").replace("$1", QtPrivate::qtro_enum_signature<ObjectType>("EngineType"));
        case 2: return QByteArrayLiteral("start()");
        case 3: return QByteArrayLiteral("increaseRpm(int)");
        case 4: return QByteArrayLiteral("unnormalizedSignature(int,int)");
        case 5: return QByteArrayLiteral("temperature()");
        case 6: return QByteArrayLiteral("setSharedTemperature(Temperature::Ptr)");
        case 7: return QByteArrayLiteral("myTestString()");
        case 8: return QByteArrayLiteral("setMyTestString(QString)");
        }
        return QByteArrayLiteral("");
    }
    QMetaMethod::MethodType methodType(int) const override
    {
        return QMetaMethod::Slot;
    }
    QByteArrayList methodParameterNames(int index) const override
    {
        if (index < 0 || index >= m_methods[0] || index + 1 >= int(std::size(m_methods)))
            return QByteArrayList();
        return ObjectType::staticMetaObject.method(m_methods[index + 1]).parameterNames();
    }
    const QByteArray typeName(int index) const override
    {
        switch (index) {
        case 0: return QByteArrayLiteral("void");
        case 1: return QByteArrayLiteral("void");
        case 2: return QByteArrayLiteral("bool");
        case 3: return QByteArrayLiteral("void");
        case 4: return QByteArrayLiteral("void");
        case 5: return QByteArrayLiteral("Temperature");
        case 6: return QByteArrayLiteral("void");
        case 7: return QByteArrayLiteral("QString");
        case 8: return QByteArrayLiteral("void");
        }
        return QByteArrayLiteral("");
    }
    QByteArray objectSignature() const override { return QByteArray{"a42bec2fbb4c1904edbce866d2b57b346622d016"}; }

    int m_enums[2];
    int m_properties[5];
    int m_signals[4];
    int m_methods[10];
    const QString m_name;
    int m_signalArgCount[3];
    const int* m_signalArgTypes[3];
    int m_methodArgCount[9];
    const int* m_methodArgTypes[9];
};


#endif // REP_ENGINE_SOURCE_H
