#ifndef REP_SPEEDOMETER_MERGED_H
#define REP_SPEEDOMETER_MERGED_H

// This is an autogenerated file.
// Do not edit this file, any changes made will be lost the next time it is generated.

#include <QtCore/qobject.h>
#include <QtCore/qdatastream.h>
#include <QtCore/qvariant.h>
#include <QtCore/qmap.h>
#include <QtCore/qmetatype.h>

#include <QtRemoteObjects/qremoteobjectnode.h>
#include <QtRemoteObjects/qremoteobjectpendingcall.h>
#include <QtRemoteObjects/qremoteobjectreplica.h>
#include <QtRemoteObjects/qremoteobjectsource.h>


using namespace Qt::Literals::StringLiterals;

class SpeedometerReplica : public QRemoteObjectReplica
{
    Q_OBJECT
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_TYPE, "Speedometer")
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_SIGNATURE, "0dce25c23392bcb848529e49e60283f15d63c141")
    Q_PROPERTY(int mph READ mph NOTIFY mphChanged)

public:
    SpeedometerReplica() : QRemoteObjectReplica() { initialize(); }
    static void registerMetatypes()
    {
        static bool initialized = false;
        if (initialized)
            return;
        initialized = true;
    }

private:
    SpeedometerReplica(QRemoteObjectNode *node, const QString &name = QString())
        : QRemoteObjectReplica(ConstructWithNode)
    {
        initializeNode(node, name);
    }

    void initialize() override
    {
        SpeedometerReplica::registerMetatypes();
        QVariantList properties;
        properties.reserve(1);
        properties << QVariant::fromValue(int());
        setProperties(std::move(properties));
    }

public:
    ~SpeedometerReplica() override = default;

    int mph() const
    {
        const QVariant variant = propAsVariant(0);
        if (!variant.canConvert<int>()) {
            qWarning() << "QtRO cannot convert the property mph to type int";
        }
        return variant.value<int >();
    }


Q_SIGNALS:
    void mphChanged(int mph);

public Q_SLOTS:
    void pushMph(int mph)
    {
        static int __repc_index = SpeedometerReplica::staticMetaObject.indexOfSlot("pushMph(int)");
        QVariantList __repc_args;
        __repc_args << QVariant::fromValue(mph);
        send(QMetaObject::InvokeMetaMethod, __repc_index, __repc_args);
    }

private:
    friend class QT_PREPEND_NAMESPACE(QRemoteObjectNode);
};

class SpeedometerSource : public QObject
{
    Q_OBJECT
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_TYPE, "Speedometer")
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_SIGNATURE, "0dce25c23392bcb848529e49e60283f15d63c141")
    Q_PROPERTY(int mph READ mph WRITE setMph NOTIFY mphChanged)

public:
    explicit SpeedometerSource(QObject *parent = nullptr) : QObject(parent)
    {
    }

public:
    ~SpeedometerSource() override = default;

    virtual int mph() const = 0;
    virtual void setMph(int mph) = 0;

Q_SIGNALS:
    void mphChanged(int mph);

public Q_SLOTS:
    virtual void pushMph(int mph)
    {
        setMph(mph);
    }

private:
    friend class QT_PREPEND_NAMESPACE(QRemoteObjectNode);
};

class SpeedometerSimpleSource : public SpeedometerSource
{
    Q_OBJECT

public:
    explicit SpeedometerSimpleSource(QObject *parent = nullptr) : SpeedometerSource(parent)
    , m_mph()
    {
    }

public:
    ~SpeedometerSimpleSource() override = default;

    int mph() const override { return m_mph; }
    void setMph(int mph) override
    {
        if (mph != m_mph) {
            m_mph = mph;
            Q_EMIT mphChanged(m_mph);
        }
    }

private:
    int m_mph;
};

template <class ObjectType>
struct SpeedometerSourceAPI : public SourceApiMap
{
    SpeedometerSourceAPI(ObjectType *object, const QString &name = QLatin1String("Speedometer"))
        : SourceApiMap(), m_name(name)
    {
        Q_UNUSED(object)
        m_enums[0] = 0;
        m_properties[0] = 1;
        m_properties[1] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::mph, static_cast<int (QObject::*)()>(nullptr),"mph");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::mphChanged, static_cast<void (QObject::*)()>(nullptr));
        m_signals[0] = 1;
        m_signals[1] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::mphChanged, static_cast<void(QObject::*)(int)>(nullptr),m_signalArgCount+0,&m_signalArgTypes[0]);
        m_methods[0] = 1;
        m_methods[1] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::pushMph, static_cast<void (QObject::*)(int)>(nullptr),"pushMph(int)",m_methodArgCount+0,&m_methodArgTypes[0]);
    }

    QString name() const override { return m_name; }
    QString typeName() const override { return QStringLiteral("Speedometer"); }
    int enumCount() const override { return m_enums[0]; }
    int propertyCount() const override { return m_properties[0]; }
    int signalCount() const override { return m_signals[0]; }
    int methodCount() const override { return m_methods[0]; }
    int sourceEnumIndex(int index) const override
    {
        if (index < 0 || index >= m_enums[0] || index + 1 >= int(std::size(m_enums)))
            return -1;
        return m_enums[index+1];
    }
    int sourcePropertyIndex(int index) const override
    {
        if (index < 0 || index >= m_properties[0] || index + 1 >= int(std::size(m_properties)))
            return -1;
        return m_properties[index+1];
    }
    int sourceSignalIndex(int index) const override
    {
        if (index < 0 || index >= m_signals[0] || index + 1 >= int(std::size(m_signals)))
            return -1;
        return m_signals[index+1];
    }
    int sourceMethodIndex(int index) const override
    {
        if (index < 0 || index >= m_methods[0] || index + 1 >= int(std::size(m_methods)))
            return -1;
        return m_methods[index+1];
    }
    int signalParameterCount(int index) const override
    {
        if (index < 0 || index >= m_signals[0])
            return -1;
        return m_signalArgCount[index];
    }
    int signalParameterType(int sigIndex, int paramIndex) const override
    {
        if (sigIndex < 0 || sigIndex >= m_signals[0] || paramIndex < 0 || paramIndex >= m_signalArgCount[sigIndex])
            return -1;
        return m_signalArgTypes[sigIndex][paramIndex];
    }
    int methodParameterCount(int index) const override
    {
        if (index < 0 || index >= m_methods[0])
            return -1;
        return m_methodArgCount[index];
    }
    int methodParameterType(int methodIndex, int paramIndex) const override
    {
        if (methodIndex < 0 || methodIndex >= m_methods[0] || paramIndex < 0 || paramIndex >= m_methodArgCount[methodIndex])
            return -1;
        return m_methodArgTypes[methodIndex][paramIndex];
    }
    int propertyIndexFromSignal(int index) const override
    {
        switch (index) {
        case 0: return m_properties[1];
        }
        return -1;
    }
    int propertyRawIndexFromSignal(int index) const override
    {
        switch (index) {
        case 0: return 0;
        }
        return -1;
    }
    const QByteArray signalSignature(int index) const override
    {
        switch (index) {
        case 0: return QByteArrayLiteral("mphChanged(int)");
        }
        return QByteArrayLiteral("");
    }
    QByteArrayList signalParameterNames(int index) const override
    {
        if (index < 0 || index >= m_signals[0] || index + 1 >= int(std::size(m_signals)))
            return QByteArrayList();
        return ObjectType::staticMetaObject.method(m_signals[index + 1]).parameterNames();
    }
    const QByteArray methodSignature(int index) const override
    {
        switch (index) {
        case 0: return QByteArrayLiteral("pushMph(int)");
        }
        return QByteArrayLiteral("");
    }
    QMetaMethod::MethodType methodType(int) const override
    {
        return QMetaMethod::Slot;
    }
    QByteArrayList methodParameterNames(int index) const override
    {
        if (index < 0 || index >= m_methods[0] || index + 1 >= int(std::size(m_methods)))
            return QByteArrayList();
        return ObjectType::staticMetaObject.method(m_methods[index + 1]).parameterNames();
    }
    const QByteArray typeName(int index) const override
    {
        switch (index) {
        case 0: return QByteArrayLiteral("void");
        }
        return QByteArrayLiteral("");
    }
    QByteArray objectSignature() const override { return QByteArray{"0dce25c23392bcb848529e49e60283f15d63c141"}; }

    int m_enums[1];
    int m_properties[2];
    int m_signals[2];
    int m_methods[2];
    const QString m_name;
    int m_signalArgCount[1];
    const int* m_signalArgTypes[1];
    int m_methodArgCount[1];
    const int* m_methodArgTypes[1];
};


#endif // REP_SPEEDOMETER_MERGED_H
