#ifndef REP_MODEL_MERGED_H
#define REP_MODEL_MERGED_H

// This is an autogenerated file.
// Do not edit this file, any changes made will be lost the next time it is generated.

#include <QtCore/qobject.h>
#include <QtCore/qdatastream.h>
#include <QtCore/qvariant.h>
#include <QtCore/qmap.h>
#include <QtCore/qmetatype.h>
#include <QtCore/qabstractitemmodel.h>

#include <QtRemoteObjects/qremoteobjectnode.h>
#include <QtRemoteObjects/qremoteobjectpendingcall.h>
#include <QtRemoteObjects/qremoteobjectreplica.h>
#include <QtRemoteObjects/qremoteobjectsource.h>
#include <QtRemoteObjects/qremoteobjectabstractitemmodelreplica.h>


using namespace Qt::Literals::StringLiterals;

class MediaReplica : public QRemoteObjectReplica
{
    Q_OBJECT
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_TYPE, "Media")
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_SIGNATURE, "4eb5e49b2122ab2aa55b2fac20c25d61f2f998bb")
    Q_CLASSINFO("TRACKS_ROLES", "display")
    Q_PROPERTY(QString currentTrack READ currentTrack NOTIFY currentTrackChanged)
    Q_PROPERTY(state playState READ playState NOTIFY playStateChanged)
    Q_PROPERTY(QAbstractItemModelReplica* tracks READ tracks NOTIFY tracksChanged)

public:
    enum state {
        Stopped = 0,
        Paused = 1,
        Playing = 2,
    };
    Q_ENUM(state)

public:
    MediaReplica() : QRemoteObjectReplica() { initialize(); }
    static void registerMetatypes()
    {
        static bool initialized = false;
        if (initialized)
            return;
        initialized = true;
        qRegisterMetaType<state>();

    }
    void setNode(QRemoteObjectNode *node) override
    {
        QRemoteObjectReplica::setNode(node);
        setChild(2, QVariant::fromValue(node->acquireModel(QRemoteObjectStringLiterals::MODEL().arg(u"Media::tracks"_s))));
        Q_EMIT tracksChanged(tracks());
    }

private:
    MediaReplica(QRemoteObjectNode *node, const QString &name = QString())
        : QRemoteObjectReplica(ConstructWithNode)
    {
        initializeNode(node, name);
        setChild(2, QVariant::fromValue(node->acquireModel(QRemoteObjectStringLiterals::MODEL().arg(u"Media::tracks"_s))));
    }

    void initialize() override
    {
        MediaReplica::registerMetatypes();
        QVariantList properties;
        properties.reserve(3);
        properties << QVariant::fromValue(QString());
        properties << QVariant::fromValue(state());
        properties << QVariant::fromValue((QAbstractItemModelReplica*)nullptr);
        setProperties(std::move(properties));
    }

public:
    ~MediaReplica() override = default;

    QString currentTrack() const
    {
        const QVariant variant = propAsVariant(0);
        if (!variant.canConvert<QString>()) {
            qWarning() << "QtRO cannot convert the property currentTrack to type QString";
        }
        return variant.value<QString >();
    }

    state playState() const
    {
        const QVariant variant = propAsVariant(1);
        if (!variant.canConvert<state>()) {
            qWarning() << "QtRO cannot convert the property playState to type state";
        }
        return variant.value<state >();
    }

    QAbstractItemModelReplica* tracks() const
    {
        const QVariant variant = propAsVariant(2);
        if (!variant.canConvert<QAbstractItemModelReplica*>()) {
            qWarning() << "QtRO cannot convert the property tracks to type QAbstractItemModelReplica*";
        }
        return variant.value<QAbstractItemModelReplica* >();
    }


Q_SIGNALS:
    void currentTrackChanged(QString currentTrack);
    void playStateChanged(MediaReplica::state playState);
    void tracksChanged(QAbstractItemModelReplica* tracks);

public Q_SLOTS:
    void pushCurrentTrack(QString currentTrack)
    {
        static int __repc_index = MediaReplica::staticMetaObject.indexOfSlot("pushCurrentTrack(QString)");
        QVariantList __repc_args;
        __repc_args << QVariant::fromValue(currentTrack);
        send(QMetaObject::InvokeMetaMethod, __repc_index, __repc_args);
    }
    void pushPlayState(MediaReplica::state playState)
    {
        static int __repc_index = MediaReplica::staticMetaObject.indexOfSlot("pushPlayState(MediaReplica::state)");
        QVariantList __repc_args;
        __repc_args << QVariant::fromValue(playState);
        send(QMetaObject::InvokeMetaMethod, __repc_index, __repc_args);
    }

private:
    friend class QT_PREPEND_NAMESPACE(QRemoteObjectNode);
};

class MediaSource : public QObject
{
    Q_OBJECT
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_TYPE, "Media")
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_SIGNATURE, "4eb5e49b2122ab2aa55b2fac20c25d61f2f998bb")
    Q_CLASSINFO("TRACKS_ROLES", "display")
    Q_PROPERTY(QString currentTrack READ currentTrack WRITE setCurrentTrack NOTIFY currentTrackChanged)
    Q_PROPERTY(state playState READ playState WRITE setPlayState NOTIFY playStateChanged)
    Q_PROPERTY(QAbstractItemModel* tracks READ tracks WRITE setTracks NOTIFY tracksChanged)

public:
    enum state {
        Stopped = 0,
        Paused = 1,
        Playing = 2,
    };
    Q_ENUM(state)

public:
    explicit MediaSource(QObject *parent = nullptr) : QObject(parent)
    {
        qRegisterMetaType<state>();

    }

public:
    ~MediaSource() override = default;

    virtual QString currentTrack() const = 0;
    virtual state playState() const = 0;
    virtual QAbstractItemModel* tracks() const = 0;
    virtual void setCurrentTrack(QString currentTrack) = 0;
    virtual void setPlayState(state playState) = 0;
    virtual void setTracks(QAbstractItemModel* tracks) = 0;

Q_SIGNALS:
    void currentTrackChanged(QString currentTrack);
    void playStateChanged(MediaSource::state playState);
    void tracksChanged(QAbstractItemModel* tracks);

public Q_SLOTS:
    virtual void pushCurrentTrack(QString currentTrack)
    {
        setCurrentTrack(currentTrack);
    }
    virtual void pushPlayState(MediaSource::state playState)
    {
        setPlayState(playState);
    }

private:
    friend class QT_PREPEND_NAMESPACE(QRemoteObjectNode);
};

class MediaSimpleSource : public MediaSource
{
    Q_OBJECT

public:
    explicit MediaSimpleSource(QObject *parent = nullptr) : MediaSource(parent)
    , m_currentTrack()
    , m_playState()
    , m_tracks(nullptr)
    {
    }

public:
    ~MediaSimpleSource() override = default;

    QString currentTrack() const override { return m_currentTrack; }
    state playState() const override { return m_playState; }
    QAbstractItemModel* tracks() const override { return m_tracks; }
    void setCurrentTrack(QString currentTrack) override
    {
        if (currentTrack != m_currentTrack) {
            m_currentTrack = currentTrack;
            Q_EMIT currentTrackChanged(m_currentTrack);
        }
    }
    void setPlayState(state playState) override
    {
        if (playState != m_playState) {
            m_playState = playState;
            Q_EMIT playStateChanged(m_playState);
        }
    }
    void setTracks(QAbstractItemModel* tracks) override
    {
        if (tracks != m_tracks) {
            m_tracks = tracks;
            Q_EMIT tracksChanged(m_tracks);
        }
    }

private:
    QString m_currentTrack;
    state m_playState;
    QAbstractItemModel* m_tracks;
};

template <class ObjectType>
struct MediaSourceAPI : public SourceApiMap
{
    // You need to add this enum as well as Q_ENUM to your
    // QObject class in order to use .rep enums over QtRO for
    // non-repc generated QObjects.
    enum state {
        Stopped = 0,
        Paused = 1,
        Playing = 2,
    };
    MediaSourceAPI(ObjectType *object, const QString &name = QLatin1String("Media"))
        : SourceApiMap(), m_name(name)
    {
        m_enums[0] = 1;
        m_enums[1] = ObjectType::staticMetaObject.indexOfEnumerator("state");
        m_properties[0] = 3;
        m_properties[1] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::currentTrack, static_cast<QString (QObject::*)()>(nullptr),"currentTrack");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::currentTrackChanged, static_cast<void (QObject::*)()>(nullptr));
        m_properties[2] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::playState, static_cast<typename ObjectType::state (QObject::*)()>(nullptr),"playState");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::playStateChanged, static_cast<void (QObject::*)()>(nullptr));
        m_properties[3] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::tracks, static_cast<QAbstractItemModel* (QObject::*)()>(nullptr),"tracks");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::tracksChanged, static_cast<void (QObject::*)()>(nullptr));
        m_signals[0] = 3;
        m_signals[1] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::currentTrackChanged, static_cast<void(QObject::*)(QString)>(nullptr),m_signalArgCount+0,&m_signalArgTypes[0]);
        m_signals[2] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::playStateChanged, static_cast<void(QObject::*)(typename ObjectType::state)>(nullptr),m_signalArgCount+1,&m_signalArgTypes[1]);
        m_signals[3] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::tracksChanged, static_cast<void(QObject::*)(QAbstractItemModel*)>(nullptr),m_signalArgCount+2,&m_signalArgTypes[2]);
        m_methods[0] = 2;
        m_methods[1] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::pushCurrentTrack, static_cast<void (QObject::*)(QString)>(nullptr),"pushCurrentTrack(QString)",m_methodArgCount+0,&m_methodArgTypes[0]);
        m_methods[2] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::pushPlayState, static_cast<void (QObject::*)(typename ObjectType::state)>(nullptr),"pushPlayState(state)",m_methodArgCount+1,&m_methodArgTypes[1]);
        m_models << ModelInfo({object->tracks(),
                               QStringLiteral("tracks"),
                               QByteArrayLiteral("display")});
    }

    QString name() const override { return m_name; }
    QString typeName() const override { return QStringLiteral("Media"); }
    int enumCount() const override { return m_enums[0]; }
    int propertyCount() const override { return m_properties[0]; }
    int signalCount() const override { return m_signals[0]; }
    int methodCount() const override { return m_methods[0]; }
    int sourceEnumIndex(int index) const override
    {
        if (index < 0 || index >= m_enums[0] || index + 1 >= int(std::size(m_enums)))
            return -1;
        return m_enums[index+1];
    }
    int sourcePropertyIndex(int index) const override
    {
        if (index < 0 || index >= m_properties[0] || index + 1 >= int(std::size(m_properties)))
            return -1;
        return m_properties[index+1];
    }
    int sourceSignalIndex(int index) const override
    {
        if (index < 0 || index >= m_signals[0] || index + 1 >= int(std::size(m_signals)))
            return -1;
        return m_signals[index+1];
    }
    int sourceMethodIndex(int index) const override
    {
        if (index < 0 || index >= m_methods[0] || index + 1 >= int(std::size(m_methods)))
            return -1;
        return m_methods[index+1];
    }
    int signalParameterCount(int index) const override
    {
        if (index < 0 || index >= m_signals[0])
            return -1;
        return m_signalArgCount[index];
    }
    int signalParameterType(int sigIndex, int paramIndex) const override
    {
        if (sigIndex < 0 || sigIndex >= m_signals[0] || paramIndex < 0 || paramIndex >= m_signalArgCount[sigIndex])
            return -1;
        return m_signalArgTypes[sigIndex][paramIndex];
    }
    int methodParameterCount(int index) const override
    {
        if (index < 0 || index >= m_methods[0])
            return -1;
        return m_methodArgCount[index];
    }
    int methodParameterType(int methodIndex, int paramIndex) const override
    {
        if (methodIndex < 0 || methodIndex >= m_methods[0] || paramIndex < 0 || paramIndex >= m_methodArgCount[methodIndex])
            return -1;
        return m_methodArgTypes[methodIndex][paramIndex];
    }
    int propertyIndexFromSignal(int index) const override
    {
        switch (index) {
        case 0: return m_properties[1];
        case 1: return m_properties[2];
        case 2: return m_properties[3];
        }
        return -1;
    }
    int propertyRawIndexFromSignal(int index) const override
    {
        switch (index) {
        case 0: return 0;
        case 1: return 1;
        case 2: return 2;
        }
        return -1;
    }
    const QByteArray signalSignature(int index) const override
    {
        switch (index) {
        case 0: return QByteArrayLiteral("currentTrackChanged(QString)");
        case 1: return QByteArrayLiteral("playStateChanged($1)").replace("$1", QtPrivate::qtro_enum_signature<ObjectType>("state"));
        case 2: return QByteArrayLiteral("tracksChanged(QAbstractItemModel*)");
        }
        return QByteArrayLiteral("");
    }
    QByteArrayList signalParameterNames(int index) const override
    {
        if (index < 0 || index >= m_signals[0] || index + 1 >= int(std::size(m_signals)))
            return QByteArrayList();
        return ObjectType::staticMetaObject.method(m_signals[index + 1]).parameterNames();
    }
    const QByteArray methodSignature(int index) const override
    {
        switch (index) {
        case 0: return QByteArrayLiteral("pushCurrentTrack(QString)");
        case 1: return QByteArrayLiteral("pushplayState($1)").replace("$1", QtPrivate::qtro_enum_signature<ObjectType>("state"));
        }
        return QByteArrayLiteral("");
    }
    QMetaMethod::MethodType methodType(int) const override
    {
        return QMetaMethod::Slot;
    }
    QByteArrayList methodParameterNames(int index) const override
    {
        if (index < 0 || index >= m_methods[0] || index + 1 >= int(std::size(m_methods)))
            return QByteArrayList();
        return ObjectType::staticMetaObject.method(m_methods[index + 1]).parameterNames();
    }
    const QByteArray typeName(int index) const override
    {
        switch (index) {
        case 0: return QByteArrayLiteral("void");
        case 1: return QByteArrayLiteral("void");
        }
        return QByteArrayLiteral("");
    }
    QByteArray objectSignature() const override { return QByteArray{"4eb5e49b2122ab2aa55b2fac20c25d61f2f998bb"}; }

    int m_enums[2];
    int m_properties[4];
    int m_signals[4];
    int m_methods[3];
    const QString m_name;
    int m_signalArgCount[3];
    const int* m_signalArgTypes[3];
    int m_methodArgCount[2];
    const int* m_methodArgTypes[2];
};

class OtherMediaReplica : public QRemoteObjectReplica
{
    Q_OBJECT
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_TYPE, "OtherMedia")
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_SIGNATURE, "5a8a1bee242f1d3625215fc2e040a075d10d7612")
    Q_CLASSINFO("TRACKS_ROLES", "display|decoration")
    Q_PROPERTY(QAbstractItemModelReplica* tracks READ tracks NOTIFY tracksChanged)

public:
    OtherMediaReplica() : QRemoteObjectReplica() { initialize(); }
    static void registerMetatypes()
    {
        static bool initialized = false;
        if (initialized)
            return;
        initialized = true;
    }
    void setNode(QRemoteObjectNode *node) override
    {
        QRemoteObjectReplica::setNode(node);
        setChild(0, QVariant::fromValue(node->acquireModel(QRemoteObjectStringLiterals::MODEL().arg(u"OtherMedia::tracks"_s))));
        Q_EMIT tracksChanged(tracks());
    }

private:
    OtherMediaReplica(QRemoteObjectNode *node, const QString &name = QString())
        : QRemoteObjectReplica(ConstructWithNode)
    {
        initializeNode(node, name);
        setChild(0, QVariant::fromValue(node->acquireModel(QRemoteObjectStringLiterals::MODEL().arg(u"OtherMedia::tracks"_s))));
    }

    void initialize() override
    {
        OtherMediaReplica::registerMetatypes();
        QVariantList properties;
        properties.reserve(1);
        properties << QVariant::fromValue((QAbstractItemModelReplica*)nullptr);
        setProperties(std::move(properties));
    }

public:
    ~OtherMediaReplica() override = default;

    QAbstractItemModelReplica* tracks() const
    {
        const QVariant variant = propAsVariant(0);
        if (!variant.canConvert<QAbstractItemModelReplica*>()) {
            qWarning() << "QtRO cannot convert the property tracks to type QAbstractItemModelReplica*";
        }
        return variant.value<QAbstractItemModelReplica* >();
    }


Q_SIGNALS:
    void tracksChanged(QAbstractItemModelReplica* tracks);

private:
    friend class QT_PREPEND_NAMESPACE(QRemoteObjectNode);
};

class OtherMediaSource : public QObject
{
    Q_OBJECT
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_TYPE, "OtherMedia")
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_SIGNATURE, "5a8a1bee242f1d3625215fc2e040a075d10d7612")
    Q_CLASSINFO("TRACKS_ROLES", "display|decoration")
    Q_PROPERTY(QAbstractItemModel* tracks READ tracks WRITE setTracks NOTIFY tracksChanged)

public:
    explicit OtherMediaSource(QObject *parent = nullptr) : QObject(parent)
    {
    }

public:
    ~OtherMediaSource() override = default;

    virtual QAbstractItemModel* tracks() const = 0;
    virtual void setTracks(QAbstractItemModel* tracks) = 0;

Q_SIGNALS:
    void tracksChanged(QAbstractItemModel* tracks);

private:
    friend class QT_PREPEND_NAMESPACE(QRemoteObjectNode);
};

class OtherMediaSimpleSource : public OtherMediaSource
{
    Q_OBJECT

public:
    explicit OtherMediaSimpleSource(QObject *parent = nullptr) : OtherMediaSource(parent)
    , m_tracks(nullptr)
    {
    }

public:
    ~OtherMediaSimpleSource() override = default;

    QAbstractItemModel* tracks() const override { return m_tracks; }
    void setTracks(QAbstractItemModel* tracks) override
    {
        if (tracks != m_tracks) {
            m_tracks = tracks;
            Q_EMIT tracksChanged(m_tracks);
        }
    }

private:
    QAbstractItemModel* m_tracks;
};

template <class ObjectType>
struct OtherMediaSourceAPI : public SourceApiMap
{
    OtherMediaSourceAPI(ObjectType *object, const QString &name = QLatin1String("OtherMedia"))
        : SourceApiMap(), m_name(name)
    {
        m_enums[0] = 0;
        m_properties[0] = 1;
        m_properties[1] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::tracks, static_cast<QAbstractItemModel* (QObject::*)()>(nullptr),"tracks");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::tracksChanged, static_cast<void (QObject::*)()>(nullptr));
        m_signals[0] = 1;
        m_signals[1] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::tracksChanged, static_cast<void(QObject::*)(QAbstractItemModel*)>(nullptr),m_signalArgCount+0,&m_signalArgTypes[0]);
        m_methods[0] = 0;
        m_models << ModelInfo({object->tracks(),
                               QStringLiteral("tracks"),
                               QByteArrayLiteral("display|decoration")});
    }

    QString name() const override { return m_name; }
    QString typeName() const override { return QStringLiteral("OtherMedia"); }
    int enumCount() const override { return m_enums[0]; }
    int propertyCount() const override { return m_properties[0]; }
    int signalCount() const override { return m_signals[0]; }
    int methodCount() const override { return m_methods[0]; }
    int sourceEnumIndex(int index) const override
    {
        if (index < 0 || index >= m_enums[0] || index + 1 >= int(std::size(m_enums)))
            return -1;
        return m_enums[index+1];
    }
    int sourcePropertyIndex(int index) const override
    {
        if (index < 0 || index >= m_properties[0] || index + 1 >= int(std::size(m_properties)))
            return -1;
        return m_properties[index+1];
    }
    int sourceSignalIndex(int index) const override
    {
        if (index < 0 || index >= m_signals[0] || index + 1 >= int(std::size(m_signals)))
            return -1;
        return m_signals[index+1];
    }
    int sourceMethodIndex(int index) const override
    {
        if (index < 0 || index >= m_methods[0] || index + 1 >= int(std::size(m_methods)))
            return -1;
        return m_methods[index+1];
    }
    int signalParameterCount(int index) const override
    {
        if (index < 0 || index >= m_signals[0])
            return -1;
        return m_signalArgCount[index];
    }
    int signalParameterType(int sigIndex, int paramIndex) const override
    {
        if (sigIndex < 0 || sigIndex >= m_signals[0] || paramIndex < 0 || paramIndex >= m_signalArgCount[sigIndex])
            return -1;
        return m_signalArgTypes[sigIndex][paramIndex];
    }
    int methodParameterCount(int index) const override { Q_UNUSED(index) return -1; }
    int methodParameterType(int methodIndex, int paramIndex) const override
    { Q_UNUSED(methodIndex) Q_UNUSED(paramIndex) return -1; }
    int propertyIndexFromSignal(int index) const override
    {
        switch (index) {
        case 0: return m_properties[1];
        }
        return -1;
    }
    int propertyRawIndexFromSignal(int index) const override
    {
        switch (index) {
        case 0: return 0;
        }
        return -1;
    }
    const QByteArray signalSignature(int index) const override
    {
        switch (index) {
        case 0: return QByteArrayLiteral("tracksChanged(QAbstractItemModel*)");
        }
        return QByteArrayLiteral("");
    }
    QByteArrayList signalParameterNames(int index) const override
    {
        if (index < 0 || index >= m_signals[0] || index + 1 >= int(std::size(m_signals)))
            return QByteArrayList();
        return ObjectType::staticMetaObject.method(m_signals[index + 1]).parameterNames();
    }
    const QByteArray methodSignature(int index) const override
    {
        Q_UNUSED(index)
        return QByteArrayLiteral("");
    }
    QMetaMethod::MethodType methodType(int) const override
    {
        return QMetaMethod::Slot;
    }
    QByteArrayList methodParameterNames(int index) const override
    {
        if (index < 0 || index >= m_methods[0] || index + 1 >= int(std::size(m_methods)))
            return QByteArrayList();
        return ObjectType::staticMetaObject.method(m_methods[index + 1]).parameterNames();
    }
    const QByteArray typeName(int index) const override
    {
        Q_UNUSED(index)
        return QByteArrayLiteral("");
    }
    QByteArray objectSignature() const override { return QByteArray{"5a8a1bee242f1d3625215fc2e040a075d10d7612"}; }

    int m_enums[1];
    int m_properties[2];
    int m_signals[2];
    int m_methods[1];
    const QString m_name;
    int m_signalArgCount[1];
    const int* m_signalArgTypes[1];
};


#endif // REP_MODEL_MERGED_H
