#ifndef REP_ENGINE_MERGED_H
#define REP_ENGINE_MERGED_H

// This is an autogenerated file.
// Do not edit this file, any changes made will be lost the next time it is generated.

#include <QtCore/qobject.h>
#include <QtCore/qdatastream.h>
#include <QtCore/qvariant.h>
#include <QtCore/qmap.h>
#include <QtCore/qmetatype.h>

#include <QtRemoteObjects/qremoteobjectnode.h>
#include <QtRemoteObjects/qremoteobjectpendingcall.h>
#include <QtRemoteObjects/qremoteobjectreplica.h>
#include <QtRemoteObjects/qremoteobjectsource.h>


using namespace Qt::Literals::StringLiterals;

class EngineReplica : public QRemoteObjectReplica
{
    Q_OBJECT
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_TYPE, "Engine")
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_SIGNATURE, "083259a28238aedcc90d9aecf1d4890726f66588")
    Q_PROPERTY(int cylinders READ cylinders NOTIFY cylindersChanged)
    Q_PROPERTY(bool started READ started NOTIFY startedChanged)
    Q_PROPERTY(int rpm READ rpm NOTIFY rpmChanged)
    Q_PROPERTY(EngineType type READ type NOTIFY typeChanged)

public:
    enum EngineType {
        Null = 0,
        Gas = 1,
        Electric = 2,
        Hybrid = 3,
    };
    Q_ENUM(EngineType)

public:
    EngineReplica() : QRemoteObjectReplica() { initialize(); }
    static void registerMetatypes()
    {
        static bool initialized = false;
        if (initialized)
            return;
        initialized = true;
        qRegisterMetaType<EngineType>();

    }

private:
    EngineReplica(QRemoteObjectNode *node, const QString &name = QString())
        : QRemoteObjectReplica(ConstructWithNode)
    {
        initializeNode(node, name);
    }

    void initialize() override
    {
        EngineReplica::registerMetatypes();
        QVariantList properties;
        properties.reserve(4);
        properties << QVariant::fromValue(int(4));
        properties << QVariant::fromValue(bool());
        properties << QVariant::fromValue(int());
        properties << QVariant::fromValue(EngineType());
        setProperties(std::move(properties));
    }

public:
    ~EngineReplica() override = default;

    int cylinders() const
    {
        const QVariant variant = propAsVariant(0);
        if (!variant.canConvert<int>()) {
            qWarning() << "QtRO cannot convert the property cylinders to type int";
        }
        return variant.value<int >();
    }

    bool started() const
    {
        const QVariant variant = propAsVariant(1);
        if (!variant.canConvert<bool>()) {
            qWarning() << "QtRO cannot convert the property started to type bool";
        }
        return variant.value<bool >();
    }

    int rpm() const
    {
        const QVariant variant = propAsVariant(2);
        if (!variant.canConvert<int>()) {
            qWarning() << "QtRO cannot convert the property rpm to type int";
        }
        return variant.value<int >();
    }

    EngineType type() const
    {
        const QVariant variant = propAsVariant(3);
        if (!variant.canConvert<EngineType>()) {
            qWarning() << "QtRO cannot convert the property type to type EngineType";
        }
        return variant.value<EngineType >();
    }


Q_SIGNALS:
    void cylindersChanged(int cylinders);
    void startedChanged(bool started);
    void rpmChanged(int rpm);
    void typeChanged(EngineReplica::EngineType type);

public Q_SLOTS:
    void pushCylinders(int cylinders)
    {
        static int __repc_index = EngineReplica::staticMetaObject.indexOfSlot("pushCylinders(int)");
        QVariantList __repc_args;
        __repc_args << QVariant::fromValue(cylinders);
        send(QMetaObject::InvokeMetaMethod, __repc_index, __repc_args);
    }
    void pushStarted(bool started)
    {
        static int __repc_index = EngineReplica::staticMetaObject.indexOfSlot("pushStarted(bool)");
        QVariantList __repc_args;
        __repc_args << QVariant::fromValue(started);
        send(QMetaObject::InvokeMetaMethod, __repc_index, __repc_args);
    }
    void pushRpm(int rpm)
    {
        static int __repc_index = EngineReplica::staticMetaObject.indexOfSlot("pushRpm(int)");
        QVariantList __repc_args;
        __repc_args << QVariant::fromValue(rpm);
        send(QMetaObject::InvokeMetaMethod, __repc_index, __repc_args);
    }
    void pushType(EngineReplica::EngineType type)
    {
        static int __repc_index = EngineReplica::staticMetaObject.indexOfSlot("pushType(EngineReplica::EngineType)");
        QVariantList __repc_args;
        __repc_args << QVariant::fromValue(type);
        send(QMetaObject::InvokeMetaMethod, __repc_index, __repc_args);
    }

private:
    friend class QT_PREPEND_NAMESPACE(QRemoteObjectNode);
};

class EngineSource : public QObject
{
    Q_OBJECT
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_TYPE, "Engine")
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_SIGNATURE, "083259a28238aedcc90d9aecf1d4890726f66588")
    Q_PROPERTY(int cylinders READ cylinders WRITE setCylinders NOTIFY cylindersChanged)
    Q_PROPERTY(bool started READ started WRITE setStarted NOTIFY startedChanged)
    Q_PROPERTY(int rpm READ rpm WRITE setRpm NOTIFY rpmChanged)
    Q_PROPERTY(EngineType type READ type WRITE setType NOTIFY typeChanged)

public:
    enum EngineType {
        Null = 0,
        Gas = 1,
        Electric = 2,
        Hybrid = 3,
    };
    Q_ENUM(EngineType)

public:
    explicit EngineSource(QObject *parent = nullptr) : QObject(parent)
    {
        qRegisterMetaType<EngineType>();

    }

public:
    ~EngineSource() override = default;

    virtual int cylinders() const = 0;
    virtual bool started() const = 0;
    virtual int rpm() const = 0;
    virtual EngineType type() const = 0;
    virtual void setCylinders(int cylinders) = 0;
    virtual void setStarted(bool started) = 0;
    virtual void setRpm(int rpm) = 0;
    virtual void setType(EngineType type) = 0;

Q_SIGNALS:
    void cylindersChanged(int cylinders);
    void startedChanged(bool started);
    void rpmChanged(int rpm);
    void typeChanged(EngineSource::EngineType type);

public Q_SLOTS:
    virtual void pushCylinders(int cylinders)
    {
        setCylinders(cylinders);
    }
    virtual void pushStarted(bool started)
    {
        setStarted(started);
    }
    virtual void pushRpm(int rpm)
    {
        setRpm(rpm);
    }
    virtual void pushType(EngineSource::EngineType type)
    {
        setType(type);
    }

private:
    friend class QT_PREPEND_NAMESPACE(QRemoteObjectNode);
};

class EngineSimpleSource : public EngineSource
{
    Q_OBJECT

public:
    explicit EngineSimpleSource(QObject *parent = nullptr) : EngineSource(parent)
    , m_cylinders(4)
    , m_started()
    , m_rpm()
    , m_type()
    {
    }

public:
    ~EngineSimpleSource() override = default;

    int cylinders() const override { return m_cylinders; }
    bool started() const override { return m_started; }
    int rpm() const override { return m_rpm; }
    EngineType type() const override { return m_type; }
    void setCylinders(int cylinders) override
    {
        if (cylinders != m_cylinders) {
            m_cylinders = cylinders;
            Q_EMIT cylindersChanged(m_cylinders);
        }
    }
    void setStarted(bool started) override
    {
        if (started != m_started) {
            m_started = started;
            Q_EMIT startedChanged(m_started);
        }
    }
    void setRpm(int rpm) override
    {
        if (rpm != m_rpm) {
            m_rpm = rpm;
            Q_EMIT rpmChanged(m_rpm);
        }
    }
    void setType(EngineType type) override
    {
        if (type != m_type) {
            m_type = type;
            Q_EMIT typeChanged(m_type);
        }
    }

private:
    int m_cylinders;
    bool m_started;
    int m_rpm;
    EngineType m_type;
};

template <class ObjectType>
struct EngineSourceAPI : public SourceApiMap
{
    // You need to add this enum as well as Q_ENUM to your
    // QObject class in order to use .rep enums over QtRO for
    // non-repc generated QObjects.
    enum EngineType {
        Null = 0,
        Gas = 1,
        Electric = 2,
        Hybrid = 3,
    };
    EngineSourceAPI(ObjectType *object, const QString &name = QLatin1String("Engine"))
        : SourceApiMap(), m_name(name)
    {
        Q_UNUSED(object)
        m_enums[0] = 1;
        m_enums[1] = ObjectType::staticMetaObject.indexOfEnumerator("EngineType");
        m_properties[0] = 4;
        m_properties[1] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::cylinders, static_cast<int (QObject::*)()>(nullptr),"cylinders");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::cylindersChanged, static_cast<void (QObject::*)()>(nullptr));
        m_properties[2] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::started, static_cast<bool (QObject::*)()>(nullptr),"started");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::startedChanged, static_cast<void (QObject::*)()>(nullptr));
        m_properties[3] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::rpm, static_cast<int (QObject::*)()>(nullptr),"rpm");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::rpmChanged, static_cast<void (QObject::*)()>(nullptr));
        m_properties[4] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::type, static_cast<typename ObjectType::EngineType (QObject::*)()>(nullptr),"type");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::typeChanged, static_cast<void (QObject::*)()>(nullptr));
        m_signals[0] = 4;
        m_signals[1] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::cylindersChanged, static_cast<void(QObject::*)(int)>(nullptr),m_signalArgCount+0,&m_signalArgTypes[0]);
        m_signals[2] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::startedChanged, static_cast<void(QObject::*)(bool)>(nullptr),m_signalArgCount+1,&m_signalArgTypes[1]);
        m_signals[3] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::rpmChanged, static_cast<void(QObject::*)(int)>(nullptr),m_signalArgCount+2,&m_signalArgTypes[2]);
        m_signals[4] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::typeChanged, static_cast<void(QObject::*)(typename ObjectType::EngineType)>(nullptr),m_signalArgCount+3,&m_signalArgTypes[3]);
        m_methods[0] = 4;
        m_methods[1] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::pushCylinders, static_cast<void (QObject::*)(int)>(nullptr),"pushCylinders(int)",m_methodArgCount+0,&m_methodArgTypes[0]);
        m_methods[2] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::pushStarted, static_cast<void (QObject::*)(bool)>(nullptr),"pushStarted(bool)",m_methodArgCount+1,&m_methodArgTypes[1]);
        m_methods[3] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::pushRpm, static_cast<void (QObject::*)(int)>(nullptr),"pushRpm(int)",m_methodArgCount+2,&m_methodArgTypes[2]);
        m_methods[4] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::pushType, static_cast<void (QObject::*)(typename ObjectType::EngineType)>(nullptr),"pushType(EngineType)",m_methodArgCount+3,&m_methodArgTypes[3]);
    }

    QString name() const override { return m_name; }
    QString typeName() const override { return QStringLiteral("Engine"); }
    int enumCount() const override { return m_enums[0]; }
    int propertyCount() const override { return m_properties[0]; }
    int signalCount() const override { return m_signals[0]; }
    int methodCount() const override { return m_methods[0]; }
    int sourceEnumIndex(int index) const override
    {
        if (index < 0 || index >= m_enums[0] || index + 1 >= int(std::size(m_enums)))
            return -1;
        return m_enums[index+1];
    }
    int sourcePropertyIndex(int index) const override
    {
        if (index < 0 || index >= m_properties[0] || index + 1 >= int(std::size(m_properties)))
            return -1;
        return m_properties[index+1];
    }
    int sourceSignalIndex(int index) const override
    {
        if (index < 0 || index >= m_signals[0] || index + 1 >= int(std::size(m_signals)))
            return -1;
        return m_signals[index+1];
    }
    int sourceMethodIndex(int index) const override
    {
        if (index < 0 || index >= m_methods[0] || index + 1 >= int(std::size(m_methods)))
            return -1;
        return m_methods[index+1];
    }
    int signalParameterCount(int index) const override
    {
        if (index < 0 || index >= m_signals[0])
            return -1;
        return m_signalArgCount[index];
    }
    int signalParameterType(int sigIndex, int paramIndex) const override
    {
        if (sigIndex < 0 || sigIndex >= m_signals[0] || paramIndex < 0 || paramIndex >= m_signalArgCount[sigIndex])
            return -1;
        return m_signalArgTypes[sigIndex][paramIndex];
    }
    int methodParameterCount(int index) const override
    {
        if (index < 0 || index >= m_methods[0])
            return -1;
        return m_methodArgCount[index];
    }
    int methodParameterType(int methodIndex, int paramIndex) const override
    {
        if (methodIndex < 0 || methodIndex >= m_methods[0] || paramIndex < 0 || paramIndex >= m_methodArgCount[methodIndex])
            return -1;
        return m_methodArgTypes[methodIndex][paramIndex];
    }
    int propertyIndexFromSignal(int index) const override
    {
        switch (index) {
        case 0: return m_properties[1];
        case 1: return m_properties[2];
        case 2: return m_properties[3];
        case 3: return m_properties[4];
        }
        return -1;
    }
    int propertyRawIndexFromSignal(int index) const override
    {
        switch (index) {
        case 0: return 0;
        case 1: return 1;
        case 2: return 2;
        case 3: return 3;
        }
        return -1;
    }
    const QByteArray signalSignature(int index) const override
    {
        switch (index) {
        case 0: return QByteArrayLiteral("cylindersChanged(int)");
        case 1: return QByteArrayLiteral("startedChanged(bool)");
        case 2: return QByteArrayLiteral("rpmChanged(int)");
        case 3: return QByteArrayLiteral("typeChanged($1)").replace("$1", QtPrivate::qtro_enum_signature<ObjectType>("EngineType"));
        }
        return QByteArrayLiteral("");
    }
    QByteArrayList signalParameterNames(int index) const override
    {
        if (index < 0 || index >= m_signals[0] || index + 1 >= int(std::size(m_signals)))
            return QByteArrayList();
        return ObjectType::staticMetaObject.method(m_signals[index + 1]).parameterNames();
    }
    const QByteArray methodSignature(int index) const override
    {
        switch (index) {
        case 0: return QByteArrayLiteral("pushCylinders(int)");
        case 1: return QByteArrayLiteral("pushStarted(bool)");
        case 2: return QByteArrayLiteral("pushRpm(int)");
        case 3: return QByteArrayLiteral("pushtype($1)").replace("$1", QtPrivate::qtro_enum_signature<ObjectType>("EngineType"));
        }
        return QByteArrayLiteral("");
    }
    QMetaMethod::MethodType methodType(int) const override
    {
        return QMetaMethod::Slot;
    }
    QByteArrayList methodParameterNames(int index) const override
    {
        if (index < 0 || index >= m_methods[0] || index + 1 >= int(std::size(m_methods)))
            return QByteArrayList();
        return ObjectType::staticMetaObject.method(m_methods[index + 1]).parameterNames();
    }
    const QByteArray typeName(int index) const override
    {
        switch (index) {
        case 0: return QByteArrayLiteral("void");
        case 1: return QByteArrayLiteral("void");
        case 2: return QByteArrayLiteral("void");
        case 3: return QByteArrayLiteral("void");
        }
        return QByteArrayLiteral("");
    }
    QByteArray objectSignature() const override { return QByteArray{"083259a28238aedcc90d9aecf1d4890726f66588"}; }

    int m_enums[2];
    int m_properties[5];
    int m_signals[5];
    int m_methods[5];
    const QString m_name;
    int m_signalArgCount[4];
    const int* m_signalArgTypes[4];
    int m_methodArgCount[4];
    const int* m_methodArgTypes[4];
};


#endif // REP_ENGINE_MERGED_H
