#ifndef REP_USERTYPES_MERGED_H
#define REP_USERTYPES_MERGED_H

// This is an autogenerated file.
// Do not edit this file, any changes made will be lost the next time it is generated.

#include <QtCore/qobject.h>
#include <QtCore/qdatastream.h>
#include <QtCore/qvariant.h>
#include <QtCore/qmap.h>
#include <QtCore/qmetatype.h>
#include <QtCore/qabstractitemmodel.h>

#include <QtRemoteObjects/qremoteobjectnode.h>
#include <QtRemoteObjects/qremoteobjectpendingcall.h>
#include <QtRemoteObjects/qremoteobjectreplica.h>
#include <QtRemoteObjects/qremoteobjectsource.h>
#include <QtRemoteObjects/qremoteobjectabstractitemmodelreplica.h>

#include <QtCore>

using namespace Qt::Literals::StringLiterals;

class SimpleClockReplica : public QRemoteObjectReplica
{
    Q_OBJECT
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_TYPE, "SimpleClock")
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_SIGNATURE, "721d6c6452affdefb243f9d937b8978a3b0304f9")
    Q_PROPERTY(int hour READ hour NOTIFY hourChanged)
    Q_PROPERTY(int minute READ minute NOTIFY minuteChanged)

public:
    SimpleClockReplica() : QRemoteObjectReplica() { initialize(); }
    static void registerMetatypes()
    {
        static bool initialized = false;
        if (initialized)
            return;
        initialized = true;
        qRegisterMetaType<QRemoteObjectPendingCall>();
        qRegisterMetaType<QRemoteObjectPendingReply<void>>();
        if (!QMetaType::hasRegisteredConverterFunction<QRemoteObjectPendingReply<void>, QRemoteObjectPendingCall>())
            QMetaType::registerConverter<QRemoteObjectPendingReply<void>, QRemoteObjectPendingCall>();

    }

private:
    SimpleClockReplica(QRemoteObjectNode *node, const QString &name = QString())
        : QRemoteObjectReplica(ConstructWithNode)
    {
        initializeNode(node, name);
    }

    void initialize() override
    {
        SimpleClockReplica::registerMetatypes();
        QVariantList properties;
        properties.reserve(2);
        properties << QVariant::fromValue(int(6));
        properties << QVariant::fromValue(int(30));
        setProperties(std::move(properties));
    }

public:
    ~SimpleClockReplica() override = default;

    int hour() const
    {
        const QVariant variant = propAsVariant(0);
        if (!variant.canConvert<int>()) {
            qWarning() << "QtRO cannot convert the property hour to type int";
        }
        return variant.value<int >();
    }

    int minute() const
    {
        const QVariant variant = propAsVariant(1);
        if (!variant.canConvert<int>()) {
            qWarning() << "QtRO cannot convert the property minute to type int";
        }
        return variant.value<int >();
    }


Q_SIGNALS:
    void hourChanged(int hour);
    void minuteChanged(int minute);
    void timeUpdated(int hour, int minute, int second=0, int millisecond=0);

public Q_SLOTS:
    void pushHour(int hour)
    {
        static int __repc_index = SimpleClockReplica::staticMetaObject.indexOfSlot("pushHour(int)");
        QVariantList __repc_args;
        __repc_args << QVariant::fromValue(hour);
        send(QMetaObject::InvokeMetaMethod, __repc_index, __repc_args);
    }
    void pushMinute(int minute)
    {
        static int __repc_index = SimpleClockReplica::staticMetaObject.indexOfSlot("pushMinute(int)");
        QVariantList __repc_args;
        __repc_args << QVariant::fromValue(minute);
        send(QMetaObject::InvokeMetaMethod, __repc_index, __repc_args);
    }

private:
    friend class QT_PREPEND_NAMESPACE(QRemoteObjectNode);
};

class SimpleClockSource : public QObject
{
    Q_OBJECT
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_TYPE, "SimpleClock")
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_SIGNATURE, "721d6c6452affdefb243f9d937b8978a3b0304f9")
    Q_PROPERTY(int hour READ hour WRITE setHour NOTIFY hourChanged)
    Q_PROPERTY(int minute READ minute WRITE setMinute NOTIFY minuteChanged)

public:
    explicit SimpleClockSource(QObject *parent = nullptr) : QObject(parent)
    {
    }

public:
    ~SimpleClockSource() override = default;

    virtual int hour() const = 0;
    virtual int minute() const = 0;
    virtual void setHour(int hour) = 0;
    virtual void setMinute(int minute) = 0;

Q_SIGNALS:
    void hourChanged(int hour);
    void minuteChanged(int minute);
    void timeUpdated(int hour, int minute, int second=0, int millisecond=0);

public Q_SLOTS:
    virtual void pushHour(int hour)
    {
        setHour(hour);
    }
    virtual void pushMinute(int minute)
    {
        setMinute(minute);
    }

private:
    friend class QT_PREPEND_NAMESPACE(QRemoteObjectNode);
};

class SimpleClockSimpleSource : public SimpleClockSource
{
    Q_OBJECT

public:
    explicit SimpleClockSimpleSource(QObject *parent = nullptr) : SimpleClockSource(parent)
    , m_hour(6)
    , m_minute(30)
    {
    }

public:
    ~SimpleClockSimpleSource() override = default;

    int hour() const override { return m_hour; }
    int minute() const override { return m_minute; }
    void setHour(int hour) override
    {
        if (hour != m_hour) {
            m_hour = hour;
            Q_EMIT hourChanged(m_hour);
        }
    }
    void setMinute(int minute) override
    {
        if (minute != m_minute) {
            m_minute = minute;
            Q_EMIT minuteChanged(m_minute);
        }
    }

private:
    int m_hour;
    int m_minute;
};

template <class ObjectType>
struct SimpleClockSourceAPI : public SourceApiMap
{
    SimpleClockSourceAPI(ObjectType *object, const QString &name = QLatin1String("SimpleClock"))
        : SourceApiMap(), m_name(name)
    {
        Q_UNUSED(object)
        m_enums[0] = 0;
        m_properties[0] = 2;
        m_properties[1] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::hour, static_cast<int (QObject::*)()>(nullptr),"hour");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::hourChanged, static_cast<void (QObject::*)()>(nullptr));
        m_properties[2] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::minute, static_cast<int (QObject::*)()>(nullptr),"minute");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::minuteChanged, static_cast<void (QObject::*)()>(nullptr));
        m_signals[0] = 3;
        m_signals[1] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::hourChanged, static_cast<void(QObject::*)(int)>(nullptr),m_signalArgCount+0,&m_signalArgTypes[0]);
        m_signals[2] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::minuteChanged, static_cast<void(QObject::*)(int)>(nullptr),m_signalArgCount+1,&m_signalArgTypes[1]);
        m_signals[3] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::timeUpdated, static_cast<void (QObject::*)(int,int,int,int)>(nullptr),m_signalArgCount+2,&m_signalArgTypes[2]);
        m_methods[0] = 2;
        m_methods[1] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::pushHour, static_cast<void (QObject::*)(int)>(nullptr),"pushHour(int)",m_methodArgCount+0,&m_methodArgTypes[0]);
        m_methods[2] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::pushMinute, static_cast<void (QObject::*)(int)>(nullptr),"pushMinute(int)",m_methodArgCount+1,&m_methodArgTypes[1]);
    }

    QString name() const override { return m_name; }
    QString typeName() const override { return QStringLiteral("SimpleClock"); }
    int enumCount() const override { return m_enums[0]; }
    int propertyCount() const override { return m_properties[0]; }
    int signalCount() const override { return m_signals[0]; }
    int methodCount() const override { return m_methods[0]; }
    int sourceEnumIndex(int index) const override
    {
        if (index < 0 || index >= m_enums[0] || index + 1 >= int(std::size(m_enums)))
            return -1;
        return m_enums[index+1];
    }
    int sourcePropertyIndex(int index) const override
    {
        if (index < 0 || index >= m_properties[0] || index + 1 >= int(std::size(m_properties)))
            return -1;
        return m_properties[index+1];
    }
    int sourceSignalIndex(int index) const override
    {
        if (index < 0 || index >= m_signals[0] || index + 1 >= int(std::size(m_signals)))
            return -1;
        return m_signals[index+1];
    }
    int sourceMethodIndex(int index) const override
    {
        if (index < 0 || index >= m_methods[0] || index + 1 >= int(std::size(m_methods)))
            return -1;
        return m_methods[index+1];
    }
    int signalParameterCount(int index) const override
    {
        if (index < 0 || index >= m_signals[0])
            return -1;
        return m_signalArgCount[index];
    }
    int signalParameterType(int sigIndex, int paramIndex) const override
    {
        if (sigIndex < 0 || sigIndex >= m_signals[0] || paramIndex < 0 || paramIndex >= m_signalArgCount[sigIndex])
            return -1;
        return m_signalArgTypes[sigIndex][paramIndex];
    }
    int methodParameterCount(int index) const override
    {
        if (index < 0 || index >= m_methods[0])
            return -1;
        return m_methodArgCount[index];
    }
    int methodParameterType(int methodIndex, int paramIndex) const override
    {
        if (methodIndex < 0 || methodIndex >= m_methods[0] || paramIndex < 0 || paramIndex >= m_methodArgCount[methodIndex])
            return -1;
        return m_methodArgTypes[methodIndex][paramIndex];
    }
    int propertyIndexFromSignal(int index) const override
    {
        switch (index) {
        case 0: return m_properties[1];
        case 1: return m_properties[2];
        }
        return -1;
    }
    int propertyRawIndexFromSignal(int index) const override
    {
        switch (index) {
        case 0: return 0;
        case 1: return 1;
        }
        return -1;
    }
    const QByteArray signalSignature(int index) const override
    {
        switch (index) {
        case 0: return QByteArrayLiteral("hourChanged(int)");
        case 1: return QByteArrayLiteral("minuteChanged(int)");
        case 2: return QByteArrayLiteral("timeUpdated(int,int,int,int)");
        }
        return QByteArrayLiteral("");
    }
    QByteArrayList signalParameterNames(int index) const override
    {
        if (index < 0 || index >= m_signals[0] || index + 1 >= int(std::size(m_signals)))
            return QByteArrayList();
        return ObjectType::staticMetaObject.method(m_signals[index + 1]).parameterNames();
    }
    const QByteArray methodSignature(int index) const override
    {
        switch (index) {
        case 0: return QByteArrayLiteral("pushHour(int)");
        case 1: return QByteArrayLiteral("pushMinute(int)");
        }
        return QByteArrayLiteral("");
    }
    QMetaMethod::MethodType methodType(int) const override
    {
        return QMetaMethod::Slot;
    }
    QByteArrayList methodParameterNames(int index) const override
    {
        if (index < 0 || index >= m_methods[0] || index + 1 >= int(std::size(m_methods)))
            return QByteArrayList();
        return ObjectType::staticMetaObject.method(m_methods[index + 1]).parameterNames();
    }
    const QByteArray typeName(int index) const override
    {
        switch (index) {
        case 0: return QByteArrayLiteral("void");
        case 1: return QByteArrayLiteral("void");
        }
        return QByteArrayLiteral("");
    }
    QByteArray objectSignature() const override { return QByteArray{"721d6c6452affdefb243f9d937b8978a3b0304f9"}; }

    int m_enums[1];
    int m_properties[3];
    int m_signals[4];
    int m_methods[3];
    const QString m_name;
    int m_signalArgCount[3];
    const int* m_signalArgTypes[3];
    int m_methodArgCount[2];
    const int* m_methodArgTypes[2];
};

class TypeWithModelReplica : public QRemoteObjectReplica
{
    Q_OBJECT
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_TYPE, "TypeWithModel")
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_SIGNATURE, "cb911ebb6b014da0c33c5217f1885b27d6ea623c")
    Q_CLASSINFO("TRACKS_ROLES", "display")
    Q_PROPERTY(QAbstractItemModelReplica* tracks READ tracks NOTIFY tracksChanged)

public:
    TypeWithModelReplica() : QRemoteObjectReplica() { initialize(); }
    static void registerMetatypes()
    {
        static bool initialized = false;
        if (initialized)
            return;
        initialized = true;
    }
    void setNode(QRemoteObjectNode *node) override
    {
        QRemoteObjectReplica::setNode(node);
        setChild(0, QVariant::fromValue(node->acquireModel(QRemoteObjectStringLiterals::MODEL().arg(u"TypeWithModel::tracks"_s))));
        Q_EMIT tracksChanged(tracks());
    }

private:
    TypeWithModelReplica(QRemoteObjectNode *node, const QString &name = QString())
        : QRemoteObjectReplica(ConstructWithNode)
    {
        initializeNode(node, name);
        setChild(0, QVariant::fromValue(node->acquireModel(QRemoteObjectStringLiterals::MODEL().arg(u"TypeWithModel::tracks"_s))));
    }

    void initialize() override
    {
        TypeWithModelReplica::registerMetatypes();
        QVariantList properties;
        properties.reserve(1);
        properties << QVariant::fromValue((QAbstractItemModelReplica*)nullptr);
        setProperties(std::move(properties));
    }

public:
    ~TypeWithModelReplica() override = default;

    QAbstractItemModelReplica* tracks() const
    {
        const QVariant variant = propAsVariant(0);
        if (!variant.canConvert<QAbstractItemModelReplica*>()) {
            qWarning() << "QtRO cannot convert the property tracks to type QAbstractItemModelReplica*";
        }
        return variant.value<QAbstractItemModelReplica* >();
    }


Q_SIGNALS:
    void tracksChanged(QAbstractItemModelReplica* tracks);

private:
    friend class QT_PREPEND_NAMESPACE(QRemoteObjectNode);
};

class TypeWithModelSource : public QObject
{
    Q_OBJECT
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_TYPE, "TypeWithModel")
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_SIGNATURE, "cb911ebb6b014da0c33c5217f1885b27d6ea623c")
    Q_CLASSINFO("TRACKS_ROLES", "display")
    Q_PROPERTY(QAbstractItemModel* tracks READ tracks WRITE setTracks NOTIFY tracksChanged)

public:
    explicit TypeWithModelSource(QObject *parent = nullptr) : QObject(parent)
    {
    }

public:
    ~TypeWithModelSource() override = default;

    virtual QAbstractItemModel* tracks() const = 0;
    virtual void setTracks(QAbstractItemModel* tracks) = 0;

Q_SIGNALS:
    void tracksChanged(QAbstractItemModel* tracks);

private:
    friend class QT_PREPEND_NAMESPACE(QRemoteObjectNode);
};

class TypeWithModelSimpleSource : public TypeWithModelSource
{
    Q_OBJECT

public:
    explicit TypeWithModelSimpleSource(QObject *parent = nullptr) : TypeWithModelSource(parent)
    , m_tracks(nullptr)
    {
    }

public:
    ~TypeWithModelSimpleSource() override = default;

    QAbstractItemModel* tracks() const override { return m_tracks; }
    void setTracks(QAbstractItemModel* tracks) override
    {
        if (tracks != m_tracks) {
            m_tracks = tracks;
            Q_EMIT tracksChanged(m_tracks);
        }
    }

private:
    QAbstractItemModel* m_tracks;
};

template <class ObjectType>
struct TypeWithModelSourceAPI : public SourceApiMap
{
    TypeWithModelSourceAPI(ObjectType *object, const QString &name = QLatin1String("TypeWithModel"))
        : SourceApiMap(), m_name(name)
    {
        m_enums[0] = 0;
        m_properties[0] = 1;
        m_properties[1] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::tracks, static_cast<QAbstractItemModel* (QObject::*)()>(nullptr),"tracks");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::tracksChanged, static_cast<void (QObject::*)()>(nullptr));
        m_signals[0] = 1;
        m_signals[1] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::tracksChanged, static_cast<void(QObject::*)(QAbstractItemModel*)>(nullptr),m_signalArgCount+0,&m_signalArgTypes[0]);
        m_methods[0] = 0;
        m_models << ModelInfo({object->tracks(),
                               QStringLiteral("tracks"),
                               QByteArrayLiteral("display")});
    }

    QString name() const override { return m_name; }
    QString typeName() const override { return QStringLiteral("TypeWithModel"); }
    int enumCount() const override { return m_enums[0]; }
    int propertyCount() const override { return m_properties[0]; }
    int signalCount() const override { return m_signals[0]; }
    int methodCount() const override { return m_methods[0]; }
    int sourceEnumIndex(int index) const override
    {
        if (index < 0 || index >= m_enums[0] || index + 1 >= int(std::size(m_enums)))
            return -1;
        return m_enums[index+1];
    }
    int sourcePropertyIndex(int index) const override
    {
        if (index < 0 || index >= m_properties[0] || index + 1 >= int(std::size(m_properties)))
            return -1;
        return m_properties[index+1];
    }
    int sourceSignalIndex(int index) const override
    {
        if (index < 0 || index >= m_signals[0] || index + 1 >= int(std::size(m_signals)))
            return -1;
        return m_signals[index+1];
    }
    int sourceMethodIndex(int index) const override
    {
        if (index < 0 || index >= m_methods[0] || index + 1 >= int(std::size(m_methods)))
            return -1;
        return m_methods[index+1];
    }
    int signalParameterCount(int index) const override
    {
        if (index < 0 || index >= m_signals[0])
            return -1;
        return m_signalArgCount[index];
    }
    int signalParameterType(int sigIndex, int paramIndex) const override
    {
        if (sigIndex < 0 || sigIndex >= m_signals[0] || paramIndex < 0 || paramIndex >= m_signalArgCount[sigIndex])
            return -1;
        return m_signalArgTypes[sigIndex][paramIndex];
    }
    int methodParameterCount(int index) const override { Q_UNUSED(index) return -1; }
    int methodParameterType(int methodIndex, int paramIndex) const override
    { Q_UNUSED(methodIndex) Q_UNUSED(paramIndex) return -1; }
    int propertyIndexFromSignal(int index) const override
    {
        switch (index) {
        case 0: return m_properties[1];
        }
        return -1;
    }
    int propertyRawIndexFromSignal(int index) const override
    {
        switch (index) {
        case 0: return 0;
        }
        return -1;
    }
    const QByteArray signalSignature(int index) const override
    {
        switch (index) {
        case 0: return QByteArrayLiteral("tracksChanged(QAbstractItemModel*)");
        }
        return QByteArrayLiteral("");
    }
    QByteArrayList signalParameterNames(int index) const override
    {
        if (index < 0 || index >= m_signals[0] || index + 1 >= int(std::size(m_signals)))
            return QByteArrayList();
        return ObjectType::staticMetaObject.method(m_signals[index + 1]).parameterNames();
    }
    const QByteArray methodSignature(int index) const override
    {
        Q_UNUSED(index)
        return QByteArrayLiteral("");
    }
    QMetaMethod::MethodType methodType(int) const override
    {
        return QMetaMethod::Slot;
    }
    QByteArrayList methodParameterNames(int index) const override
    {
        if (index < 0 || index >= m_methods[0] || index + 1 >= int(std::size(m_methods)))
            return QByteArrayList();
        return ObjectType::staticMetaObject.method(m_methods[index + 1]).parameterNames();
    }
    const QByteArray typeName(int index) const override
    {
        Q_UNUSED(index)
        return QByteArrayLiteral("");
    }
    QByteArray objectSignature() const override { return QByteArray{"cb911ebb6b014da0c33c5217f1885b27d6ea623c"}; }

    int m_enums[1];
    int m_properties[2];
    int m_signals[2];
    int m_methods[1];
    const QString m_name;
    int m_signalArgCount[1];
    const int* m_signalArgTypes[1];
};

class TypeWithSubObjectReplica : public QRemoteObjectReplica
{
    Q_OBJECT
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_TYPE, "TypeWithSubObject")
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_SIGNATURE, "cc7dccb18b121cd0324d0d8e9c9c906754e77a6f")
    Q_PROPERTY(SimpleClockReplica* clock READ clock NOTIFY clockChanged)

public:
    TypeWithSubObjectReplica() : QRemoteObjectReplica() { initialize(); }
    static void registerMetatypes()
    {
        static bool initialized = false;
        if (initialized)
            return;
        initialized = true;
    }
    void setNode(QRemoteObjectNode *node) override
    {
        QRemoteObjectReplica::setNode(node);
        setChild(0, QVariant::fromValue(node->acquire<SimpleClockReplica>(QRemoteObjectStringLiterals::CLASS().arg(u"TypeWithSubObject::clock"_s))));
        Q_EMIT clockChanged(clock());
    }

private:
    TypeWithSubObjectReplica(QRemoteObjectNode *node, const QString &name = QString())
        : QRemoteObjectReplica(ConstructWithNode)
    {
        initializeNode(node, name);
        setChild(0, QVariant::fromValue(node->acquire<SimpleClockReplica>(QRemoteObjectStringLiterals::CLASS().arg(u"TypeWithSubObject::clock"_s))));
    }

    void initialize() override
    {
        TypeWithSubObjectReplica::registerMetatypes();
        QVariantList properties;
        properties.reserve(1);
        properties << QVariant::fromValue((SimpleClockReplica*)nullptr);
        setProperties(std::move(properties));
    }

public:
    ~TypeWithSubObjectReplica() override = default;

    SimpleClockReplica* clock() const
    {
        const QVariant variant = propAsVariant(0);
        if (!variant.canConvert<SimpleClockReplica*>()) {
            qWarning() << "QtRO cannot convert the property clock to type SimpleClockReplica*";
        }
        return variant.value<SimpleClockReplica* >();
    }


Q_SIGNALS:
    void clockChanged(SimpleClockReplica* clock);

private:
    friend class QT_PREPEND_NAMESPACE(QRemoteObjectNode);
};

class TypeWithSubObjectSource : public QObject
{
    Q_OBJECT
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_TYPE, "TypeWithSubObject")
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_SIGNATURE, "cc7dccb18b121cd0324d0d8e9c9c906754e77a6f")
    Q_PROPERTY(SimpleClockSource* clock READ clock WRITE setClock NOTIFY clockChanged)

public:
    explicit TypeWithSubObjectSource(QObject *parent = nullptr) : QObject(parent)
    {
    }

public:
    ~TypeWithSubObjectSource() override = default;

    virtual SimpleClockSource* clock() const = 0;
    virtual void setClock(SimpleClockSource* clock) = 0;

Q_SIGNALS:
    void clockChanged(SimpleClockSource* clock);

private:
    friend class QT_PREPEND_NAMESPACE(QRemoteObjectNode);
};

class TypeWithSubObjectSimpleSource : public TypeWithSubObjectSource
{
    Q_OBJECT

public:
    explicit TypeWithSubObjectSimpleSource(QObject *parent = nullptr) : TypeWithSubObjectSource(parent)
    , m_clock(nullptr)
    {
    }

public:
    ~TypeWithSubObjectSimpleSource() override = default;

    SimpleClockSource* clock() const override { return m_clock; }
    void setClock(SimpleClockSource* clock) override
    {
        if (clock != m_clock) {
            m_clock = clock;
            Q_EMIT clockChanged(m_clock);
        }
    }

private:
    SimpleClockSource* m_clock;
};

template <class ObjectType>
struct TypeWithSubObjectSourceAPI : public SourceApiMap
{
    TypeWithSubObjectSourceAPI(ObjectType *object, const QString &name = QLatin1String("TypeWithSubObject"))
        : SourceApiMap(), m_name(name)
    {
        using clock_type_t = typename std::remove_pointer<decltype(object->clock())>::type;
        m_enums[0] = 0;
        m_properties[0] = 1;
        m_properties[1] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::clock, static_cast<SimpleClockSource* (QObject::*)()>(nullptr),"clock");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::clockChanged, static_cast<void (QObject::*)()>(nullptr));
        m_signals[0] = 1;
        m_signals[1] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::clockChanged, static_cast<void(QObject::*)(SimpleClockSource*)>(nullptr),m_signalArgCount+0,&m_signalArgTypes[0]);
        m_methods[0] = 0;
        m_subclasses << new SimpleClockSourceAPI<clock_type_t>(object->clock(), QStringLiteral("clock"));
    }

    QString name() const override { return m_name; }
    QString typeName() const override { return QStringLiteral("TypeWithSubObject"); }
    int enumCount() const override { return m_enums[0]; }
    int propertyCount() const override { return m_properties[0]; }
    int signalCount() const override { return m_signals[0]; }
    int methodCount() const override { return m_methods[0]; }
    int sourceEnumIndex(int index) const override
    {
        if (index < 0 || index >= m_enums[0] || index + 1 >= int(std::size(m_enums)))
            return -1;
        return m_enums[index+1];
    }
    int sourcePropertyIndex(int index) const override
    {
        if (index < 0 || index >= m_properties[0] || index + 1 >= int(std::size(m_properties)))
            return -1;
        return m_properties[index+1];
    }
    int sourceSignalIndex(int index) const override
    {
        if (index < 0 || index >= m_signals[0] || index + 1 >= int(std::size(m_signals)))
            return -1;
        return m_signals[index+1];
    }
    int sourceMethodIndex(int index) const override
    {
        if (index < 0 || index >= m_methods[0] || index + 1 >= int(std::size(m_methods)))
            return -1;
        return m_methods[index+1];
    }
    int signalParameterCount(int index) const override
    {
        if (index < 0 || index >= m_signals[0])
            return -1;
        return m_signalArgCount[index];
    }
    int signalParameterType(int sigIndex, int paramIndex) const override
    {
        if (sigIndex < 0 || sigIndex >= m_signals[0] || paramIndex < 0 || paramIndex >= m_signalArgCount[sigIndex])
            return -1;
        return m_signalArgTypes[sigIndex][paramIndex];
    }
    int methodParameterCount(int index) const override { Q_UNUSED(index) return -1; }
    int methodParameterType(int methodIndex, int paramIndex) const override
    { Q_UNUSED(methodIndex) Q_UNUSED(paramIndex) return -1; }
    int propertyIndexFromSignal(int index) const override
    {
        switch (index) {
        case 0: return m_properties[1];
        }
        return -1;
    }
    int propertyRawIndexFromSignal(int index) const override
    {
        switch (index) {
        case 0: return 0;
        }
        return -1;
    }
    const QByteArray signalSignature(int index) const override
    {
        switch (index) {
        case 0: return QByteArrayLiteral("clockChanged(SimpleClockSource*)");
        }
        return QByteArrayLiteral("");
    }
    QByteArrayList signalParameterNames(int index) const override
    {
        if (index < 0 || index >= m_signals[0] || index + 1 >= int(std::size(m_signals)))
            return QByteArrayList();
        return ObjectType::staticMetaObject.method(m_signals[index + 1]).parameterNames();
    }
    const QByteArray methodSignature(int index) const override
    {
        Q_UNUSED(index)
        return QByteArrayLiteral("");
    }
    QMetaMethod::MethodType methodType(int) const override
    {
        return QMetaMethod::Slot;
    }
    QByteArrayList methodParameterNames(int index) const override
    {
        if (index < 0 || index >= m_methods[0] || index + 1 >= int(std::size(m_methods)))
            return QByteArrayList();
        return ObjectType::staticMetaObject.method(m_methods[index + 1]).parameterNames();
    }
    const QByteArray typeName(int index) const override
    {
        Q_UNUSED(index)
        return QByteArrayLiteral("");
    }
    QByteArray objectSignature() const override { return QByteArray{"cc7dccb18b121cd0324d0d8e9c9c906754e77a6f"}; }

    int m_enums[1];
    int m_properties[2];
    int m_signals[2];
    int m_methods[1];
    const QString m_name;
    int m_signalArgCount[1];
    const int* m_signalArgTypes[1];
};

class ComplexTypeReplica : public QRemoteObjectReplica
{
    Q_OBJECT
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_TYPE, "ComplexType")
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_SIGNATURE, "194dbdf5660debec4e102ee7818d80ec7e5439e6")
    Q_CLASSINFO("TRACKS_ROLES", "display")
    Q_PROPERTY(int before READ before NOTIFY beforeChanged)
    Q_PROPERTY(QAbstractItemModelReplica* tracks READ tracks NOTIFY tracksChanged)
    Q_PROPERTY(SimpleClockReplica* clock READ clock NOTIFY clockChanged)
    Q_PROPERTY(int after READ after NOTIFY afterChanged)

public:
    ComplexTypeReplica() : QRemoteObjectReplica() { initialize(); }
    static void registerMetatypes()
    {
        static bool initialized = false;
        if (initialized)
            return;
        initialized = true;
    }
    void setNode(QRemoteObjectNode *node) override
    {
        QRemoteObjectReplica::setNode(node);
        setChild(1, QVariant::fromValue(node->acquireModel(QRemoteObjectStringLiterals::MODEL().arg(u"ComplexType::tracks"_s))));
        Q_EMIT tracksChanged(tracks());
        setChild(2, QVariant::fromValue(node->acquire<SimpleClockReplica>(QRemoteObjectStringLiterals::CLASS().arg(u"ComplexType::clock"_s))));
        Q_EMIT clockChanged(clock());
    }

private:
    ComplexTypeReplica(QRemoteObjectNode *node, const QString &name = QString())
        : QRemoteObjectReplica(ConstructWithNode)
    {
        initializeNode(node, name);
        setChild(1, QVariant::fromValue(node->acquireModel(QRemoteObjectStringLiterals::MODEL().arg(u"ComplexType::tracks"_s))));
        setChild(2, QVariant::fromValue(node->acquire<SimpleClockReplica>(QRemoteObjectStringLiterals::CLASS().arg(u"ComplexType::clock"_s))));
    }

    void initialize() override
    {
        ComplexTypeReplica::registerMetatypes();
        QVariantList properties;
        properties.reserve(4);
        properties << QVariant::fromValue(int(0));
        properties << QVariant::fromValue((QAbstractItemModelReplica*)nullptr);
        properties << QVariant::fromValue((SimpleClockReplica*)nullptr);
        properties << QVariant::fromValue(int(42));
        setProperties(std::move(properties));
    }

public:
    ~ComplexTypeReplica() override = default;

    int before() const
    {
        const QVariant variant = propAsVariant(0);
        if (!variant.canConvert<int>()) {
            qWarning() << "QtRO cannot convert the property before to type int";
        }
        return variant.value<int >();
    }

    QAbstractItemModelReplica* tracks() const
    {
        const QVariant variant = propAsVariant(1);
        if (!variant.canConvert<QAbstractItemModelReplica*>()) {
            qWarning() << "QtRO cannot convert the property tracks to type QAbstractItemModelReplica*";
        }
        return variant.value<QAbstractItemModelReplica* >();
    }

    SimpleClockReplica* clock() const
    {
        const QVariant variant = propAsVariant(2);
        if (!variant.canConvert<SimpleClockReplica*>()) {
            qWarning() << "QtRO cannot convert the property clock to type SimpleClockReplica*";
        }
        return variant.value<SimpleClockReplica* >();
    }

    int after() const
    {
        const QVariant variant = propAsVariant(3);
        if (!variant.canConvert<int>()) {
            qWarning() << "QtRO cannot convert the property after to type int";
        }
        return variant.value<int >();
    }


Q_SIGNALS:
    void beforeChanged(int before);
    void tracksChanged(QAbstractItemModelReplica* tracks);
    void clockChanged(SimpleClockReplica* clock);
    void afterChanged(int after);

public Q_SLOTS:
    void pushBefore(int before)
    {
        static int __repc_index = ComplexTypeReplica::staticMetaObject.indexOfSlot("pushBefore(int)");
        QVariantList __repc_args;
        __repc_args << QVariant::fromValue(before);
        send(QMetaObject::InvokeMetaMethod, __repc_index, __repc_args);
    }
    void pushAfter(int after)
    {
        static int __repc_index = ComplexTypeReplica::staticMetaObject.indexOfSlot("pushAfter(int)");
        QVariantList __repc_args;
        __repc_args << QVariant::fromValue(after);
        send(QMetaObject::InvokeMetaMethod, __repc_index, __repc_args);
    }

private:
    friend class QT_PREPEND_NAMESPACE(QRemoteObjectNode);
};

class ComplexTypeSource : public QObject
{
    Q_OBJECT
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_TYPE, "ComplexType")
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_SIGNATURE, "194dbdf5660debec4e102ee7818d80ec7e5439e6")
    Q_CLASSINFO("TRACKS_ROLES", "display")
    Q_PROPERTY(int before READ before WRITE setBefore NOTIFY beforeChanged)
    Q_PROPERTY(QAbstractItemModel* tracks READ tracks WRITE setTracks NOTIFY tracksChanged)
    Q_PROPERTY(SimpleClockSource* clock READ clock WRITE setClock NOTIFY clockChanged)
    Q_PROPERTY(int after READ after WRITE setAfter NOTIFY afterChanged)

public:
    explicit ComplexTypeSource(QObject *parent = nullptr) : QObject(parent)
    {
    }

public:
    ~ComplexTypeSource() override = default;

    virtual int before() const = 0;
    virtual QAbstractItemModel* tracks() const = 0;
    virtual SimpleClockSource* clock() const = 0;
    virtual int after() const = 0;
    virtual void setBefore(int before) = 0;
    virtual void setTracks(QAbstractItemModel* tracks) = 0;
    virtual void setClock(SimpleClockSource* clock) = 0;
    virtual void setAfter(int after) = 0;

Q_SIGNALS:
    void beforeChanged(int before);
    void tracksChanged(QAbstractItemModel* tracks);
    void clockChanged(SimpleClockSource* clock);
    void afterChanged(int after);

public Q_SLOTS:
    virtual void pushBefore(int before)
    {
        setBefore(before);
    }
    virtual void pushAfter(int after)
    {
        setAfter(after);
    }

private:
    friend class QT_PREPEND_NAMESPACE(QRemoteObjectNode);
};

class ComplexTypeSimpleSource : public ComplexTypeSource
{
    Q_OBJECT

public:
    explicit ComplexTypeSimpleSource(QObject *parent = nullptr) : ComplexTypeSource(parent)
    , m_before(0)
    , m_tracks(nullptr)
    , m_clock(nullptr)
    , m_after(42)
    {
    }

public:
    ~ComplexTypeSimpleSource() override = default;

    int before() const override { return m_before; }
    QAbstractItemModel* tracks() const override { return m_tracks; }
    SimpleClockSource* clock() const override { return m_clock; }
    int after() const override { return m_after; }
    void setBefore(int before) override
    {
        if (before != m_before) {
            m_before = before;
            Q_EMIT beforeChanged(m_before);
        }
    }
    void setTracks(QAbstractItemModel* tracks) override
    {
        if (tracks != m_tracks) {
            m_tracks = tracks;
            Q_EMIT tracksChanged(m_tracks);
        }
    }
    void setClock(SimpleClockSource* clock) override
    {
        if (clock != m_clock) {
            m_clock = clock;
            Q_EMIT clockChanged(m_clock);
        }
    }
    void setAfter(int after) override
    {
        if (after != m_after) {
            m_after = after;
            Q_EMIT afterChanged(m_after);
        }
    }

private:
    int m_before;
    QAbstractItemModel* m_tracks;
    SimpleClockSource* m_clock;
    int m_after;
};

template <class ObjectType>
struct ComplexTypeSourceAPI : public SourceApiMap
{
    ComplexTypeSourceAPI(ObjectType *object, const QString &name = QLatin1String("ComplexType"))
        : SourceApiMap(), m_name(name)
    {
        using clock_type_t = typename std::remove_pointer<decltype(object->clock())>::type;
        m_enums[0] = 0;
        m_properties[0] = 4;
        m_properties[1] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::before, static_cast<int (QObject::*)()>(nullptr),"before");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::beforeChanged, static_cast<void (QObject::*)()>(nullptr));
        m_properties[2] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::tracks, static_cast<QAbstractItemModel* (QObject::*)()>(nullptr),"tracks");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::tracksChanged, static_cast<void (QObject::*)()>(nullptr));
        m_properties[3] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::clock, static_cast<SimpleClockSource* (QObject::*)()>(nullptr),"clock");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::clockChanged, static_cast<void (QObject::*)()>(nullptr));
        m_properties[4] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::after, static_cast<int (QObject::*)()>(nullptr),"after");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::afterChanged, static_cast<void (QObject::*)()>(nullptr));
        m_signals[0] = 4;
        m_signals[1] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::beforeChanged, static_cast<void(QObject::*)(int)>(nullptr),m_signalArgCount+0,&m_signalArgTypes[0]);
        m_signals[2] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::tracksChanged, static_cast<void(QObject::*)(QAbstractItemModel*)>(nullptr),m_signalArgCount+1,&m_signalArgTypes[1]);
        m_signals[3] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::clockChanged, static_cast<void(QObject::*)(SimpleClockSource*)>(nullptr),m_signalArgCount+2,&m_signalArgTypes[2]);
        m_signals[4] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::afterChanged, static_cast<void(QObject::*)(int)>(nullptr),m_signalArgCount+3,&m_signalArgTypes[3]);
        m_methods[0] = 2;
        m_methods[1] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::pushBefore, static_cast<void (QObject::*)(int)>(nullptr),"pushBefore(int)",m_methodArgCount+0,&m_methodArgTypes[0]);
        m_methods[2] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::pushAfter, static_cast<void (QObject::*)(int)>(nullptr),"pushAfter(int)",m_methodArgCount+1,&m_methodArgTypes[1]);
        m_models << ModelInfo({object->tracks(),
                               QStringLiteral("tracks"),
                               QByteArrayLiteral("display")});
        m_subclasses << new SimpleClockSourceAPI<clock_type_t>(object->clock(), QStringLiteral("clock"));
    }

    QString name() const override { return m_name; }
    QString typeName() const override { return QStringLiteral("ComplexType"); }
    int enumCount() const override { return m_enums[0]; }
    int propertyCount() const override { return m_properties[0]; }
    int signalCount() const override { return m_signals[0]; }
    int methodCount() const override { return m_methods[0]; }
    int sourceEnumIndex(int index) const override
    {
        if (index < 0 || index >= m_enums[0] || index + 1 >= int(std::size(m_enums)))
            return -1;
        return m_enums[index+1];
    }
    int sourcePropertyIndex(int index) const override
    {
        if (index < 0 || index >= m_properties[0] || index + 1 >= int(std::size(m_properties)))
            return -1;
        return m_properties[index+1];
    }
    int sourceSignalIndex(int index) const override
    {
        if (index < 0 || index >= m_signals[0] || index + 1 >= int(std::size(m_signals)))
            return -1;
        return m_signals[index+1];
    }
    int sourceMethodIndex(int index) const override
    {
        if (index < 0 || index >= m_methods[0] || index + 1 >= int(std::size(m_methods)))
            return -1;
        return m_methods[index+1];
    }
    int signalParameterCount(int index) const override
    {
        if (index < 0 || index >= m_signals[0])
            return -1;
        return m_signalArgCount[index];
    }
    int signalParameterType(int sigIndex, int paramIndex) const override
    {
        if (sigIndex < 0 || sigIndex >= m_signals[0] || paramIndex < 0 || paramIndex >= m_signalArgCount[sigIndex])
            return -1;
        return m_signalArgTypes[sigIndex][paramIndex];
    }
    int methodParameterCount(int index) const override
    {
        if (index < 0 || index >= m_methods[0])
            return -1;
        return m_methodArgCount[index];
    }
    int methodParameterType(int methodIndex, int paramIndex) const override
    {
        if (methodIndex < 0 || methodIndex >= m_methods[0] || paramIndex < 0 || paramIndex >= m_methodArgCount[methodIndex])
            return -1;
        return m_methodArgTypes[methodIndex][paramIndex];
    }
    int propertyIndexFromSignal(int index) const override
    {
        switch (index) {
        case 0: return m_properties[1];
        case 1: return m_properties[2];
        case 2: return m_properties[3];
        case 3: return m_properties[4];
        }
        return -1;
    }
    int propertyRawIndexFromSignal(int index) const override
    {
        switch (index) {
        case 0: return 0;
        case 1: return 1;
        case 2: return 2;
        case 3: return 3;
        }
        return -1;
    }
    const QByteArray signalSignature(int index) const override
    {
        switch (index) {
        case 0: return QByteArrayLiteral("beforeChanged(int)");
        case 1: return QByteArrayLiteral("tracksChanged(QAbstractItemModel*)");
        case 2: return QByteArrayLiteral("clockChanged(SimpleClockSource*)");
        case 3: return QByteArrayLiteral("afterChanged(int)");
        }
        return QByteArrayLiteral("");
    }
    QByteArrayList signalParameterNames(int index) const override
    {
        if (index < 0 || index >= m_signals[0] || index + 1 >= int(std::size(m_signals)))
            return QByteArrayList();
        return ObjectType::staticMetaObject.method(m_signals[index + 1]).parameterNames();
    }
    const QByteArray methodSignature(int index) const override
    {
        switch (index) {
        case 0: return QByteArrayLiteral("pushBefore(int)");
        case 1: return QByteArrayLiteral("pushAfter(int)");
        }
        return QByteArrayLiteral("");
    }
    QMetaMethod::MethodType methodType(int) const override
    {
        return QMetaMethod::Slot;
    }
    QByteArrayList methodParameterNames(int index) const override
    {
        if (index < 0 || index >= m_methods[0] || index + 1 >= int(std::size(m_methods)))
            return QByteArrayList();
        return ObjectType::staticMetaObject.method(m_methods[index + 1]).parameterNames();
    }
    const QByteArray typeName(int index) const override
    {
        switch (index) {
        case 0: return QByteArrayLiteral("void");
        case 1: return QByteArrayLiteral("void");
        }
        return QByteArrayLiteral("");
    }
    QByteArray objectSignature() const override { return QByteArray{"194dbdf5660debec4e102ee7818d80ec7e5439e6"}; }

    int m_enums[1];
    int m_properties[5];
    int m_signals[5];
    int m_methods[3];
    const QString m_name;
    int m_signalArgCount[4];
    const int* m_signalArgTypes[4];
    int m_methodArgCount[2];
    const int* m_methodArgTypes[2];
};

class TypeWithReplyReplica : public QRemoteObjectReplica
{
    Q_OBJECT
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_TYPE, "TypeWithReply")
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_SIGNATURE, "6591e428008fc9894ecd0b19856d06dc713ac608")

public:
    TypeWithReplyReplica() : QRemoteObjectReplica() { initialize(); }
    static void registerMetatypes()
    {
        static bool initialized = false;
        if (initialized)
            return;
        initialized = true;
        qRegisterMetaType<QMap<QString, QString>>();
        qRegisterMetaType<QRemoteObjectPendingCall>();
        qRegisterMetaType<QRemoteObjectPendingReply<int>>();
        if (!QMetaType::hasRegisteredConverterFunction<QRemoteObjectPendingReply<int>, QRemoteObjectPendingCall>())
            QMetaType::registerConverter<QRemoteObjectPendingReply<int>, QRemoteObjectPendingCall>();
        qRegisterMetaType<QRemoteObjectPendingReply<QMap<QString, QString>>>();
        if (!QMetaType::hasRegisteredConverterFunction<QRemoteObjectPendingReply<QMap<QString, QString>>, QRemoteObjectPendingCall>())
            QMetaType::registerConverter<QRemoteObjectPendingReply<QMap<QString, QString>>, QRemoteObjectPendingCall>();
        qRegisterMetaType<QRemoteObjectPendingReply<QString>>();
        if (!QMetaType::hasRegisteredConverterFunction<QRemoteObjectPendingReply<QString>, QRemoteObjectPendingCall>())
            QMetaType::registerConverter<QRemoteObjectPendingReply<QString>, QRemoteObjectPendingCall>();

    }

private:
    TypeWithReplyReplica(QRemoteObjectNode *node, const QString &name = QString())
        : QRemoteObjectReplica(ConstructWithNode)
    {
        initializeNode(node, name);
    }

    void initialize() override
    {
        TypeWithReplyReplica::registerMetatypes();
        QVariantList properties;
        properties.reserve(0);
        setProperties(std::move(properties));
    }

public:
    ~TypeWithReplyReplica() override = default;


public Q_SLOTS:
    QRemoteObjectPendingReply<QString> uppercase(const QString & input)
    {
        static int __repc_index = TypeWithReplyReplica::staticMetaObject.indexOfSlot("uppercase(QString)");
        QVariantList __repc_args;
        __repc_args
            << QVariant::fromValue(input)
        ;
        return QRemoteObjectPendingReply<QString>(sendWithReply(QMetaObject::InvokeMetaMethod, __repc_index, __repc_args));
    }
    QRemoteObjectPendingReply<QMap<QString, QString>> complexReturnType()
    {
        static int __repc_index = TypeWithReplyReplica::staticMetaObject.indexOfSlot("complexReturnType()");
        QVariantList __repc_args;
        return QRemoteObjectPendingReply<QMap<QString, QString>>(sendWithReply(QMetaObject::InvokeMetaMethod, __repc_index, __repc_args));
    }
    QRemoteObjectPendingReply<int> slowFunction()
    {
        static int __repc_index = TypeWithReplyReplica::staticMetaObject.indexOfSlot("slowFunction()");
        QVariantList __repc_args;
        return QRemoteObjectPendingReply<int>(sendWithReply(QMetaObject::InvokeMetaMethod, __repc_index, __repc_args));
    }

private:
    friend class QT_PREPEND_NAMESPACE(QRemoteObjectNode);
};

class TypeWithReplySource : public QObject
{
    Q_OBJECT
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_TYPE, "TypeWithReply")
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_SIGNATURE, "6591e428008fc9894ecd0b19856d06dc713ac608")

public:
    explicit TypeWithReplySource(QObject *parent = nullptr) : QObject(parent)
    {
        qRegisterMetaType<QMap<QString, QString>>();

    }

public:
    ~TypeWithReplySource() override = default;


public Q_SLOTS:
    virtual QString uppercase(const QString & input) = 0;
    virtual QMap<QString, QString> complexReturnType() = 0;
    virtual int slowFunction() = 0;

private:
    friend class QT_PREPEND_NAMESPACE(QRemoteObjectNode);
};

class TypeWithReplySimpleSource : public TypeWithReplySource
{
    Q_OBJECT

public:
    explicit TypeWithReplySimpleSource(QObject *parent = nullptr) : TypeWithReplySource(parent)
    {
    }

public:
    ~TypeWithReplySimpleSource() override = default;


private:
};

template <class ObjectType>
struct TypeWithReplySourceAPI : public SourceApiMap
{
    TypeWithReplySourceAPI(ObjectType *object, const QString &name = QLatin1String("TypeWithReply"))
        : SourceApiMap(), m_name(name)
    {
        Q_UNUSED(object)
        m_enums[0] = 0;
        m_properties[0] = 0;
        m_signals[0] = 0;
        m_methods[0] = 3;
        m_methods[1] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::uppercase, static_cast<void (QObject::*)(QString)>(nullptr),"uppercase(QString)",m_methodArgCount+0,&m_methodArgTypes[0]);
        m_methods[2] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::complexReturnType, static_cast<void (QObject::*)()>(nullptr),"complexReturnType()",m_methodArgCount+1,&m_methodArgTypes[1]);
        m_methods[3] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::slowFunction, static_cast<void (QObject::*)()>(nullptr),"slowFunction()",m_methodArgCount+2,&m_methodArgTypes[2]);
    }

    QString name() const override { return m_name; }
    QString typeName() const override { return QStringLiteral("TypeWithReply"); }
    int enumCount() const override { return m_enums[0]; }
    int propertyCount() const override { return m_properties[0]; }
    int signalCount() const override { return m_signals[0]; }
    int methodCount() const override { return m_methods[0]; }
    int sourceEnumIndex(int index) const override
    {
        if (index < 0 || index >= m_enums[0] || index + 1 >= int(std::size(m_enums)))
            return -1;
        return m_enums[index+1];
    }
    int sourcePropertyIndex(int index) const override
    {
        if (index < 0 || index >= m_properties[0] || index + 1 >= int(std::size(m_properties)))
            return -1;
        return m_properties[index+1];
    }
    int sourceSignalIndex(int index) const override
    {
        if (index < 0 || index >= m_signals[0] || index + 1 >= int(std::size(m_signals)))
            return -1;
        return m_signals[index+1];
    }
    int sourceMethodIndex(int index) const override
    {
        if (index < 0 || index >= m_methods[0] || index + 1 >= int(std::size(m_methods)))
            return -1;
        return m_methods[index+1];
    }
    int signalParameterCount(int index) const override { Q_UNUSED(index) return -1; }
    int signalParameterType(int sigIndex, int paramIndex) const override
    { Q_UNUSED(sigIndex) Q_UNUSED(paramIndex) return -1; }
    int methodParameterCount(int index) const override
    {
        if (index < 0 || index >= m_methods[0])
            return -1;
        return m_methodArgCount[index];
    }
    int methodParameterType(int methodIndex, int paramIndex) const override
    {
        if (methodIndex < 0 || methodIndex >= m_methods[0] || paramIndex < 0 || paramIndex >= m_methodArgCount[methodIndex])
            return -1;
        return m_methodArgTypes[methodIndex][paramIndex];
    }
    int propertyIndexFromSignal(int index) const override
    {
        Q_UNUSED(index)
        return -1;
    }
    int propertyRawIndexFromSignal(int index) const override
    {
        Q_UNUSED(index)
        return -1;
    }
    const QByteArray signalSignature(int index) const override
    {
        Q_UNUSED(index)
        return QByteArrayLiteral("");
    }
    QByteArrayList signalParameterNames(int index) const override
    {
        if (index < 0 || index >= m_signals[0] || index + 1 >= int(std::size(m_signals)))
            return QByteArrayList();
        return ObjectType::staticMetaObject.method(m_signals[index + 1]).parameterNames();
    }
    const QByteArray methodSignature(int index) const override
    {
        switch (index) {
        case 0: return QByteArrayLiteral("uppercase(QString)");
        case 1: return QByteArrayLiteral("complexReturnType()");
        case 2: return QByteArrayLiteral("slowFunction()");
        }
        return QByteArrayLiteral("");
    }
    QMetaMethod::MethodType methodType(int) const override
    {
        return QMetaMethod::Slot;
    }
    QByteArrayList methodParameterNames(int index) const override
    {
        if (index < 0 || index >= m_methods[0] || index + 1 >= int(std::size(m_methods)))
            return QByteArrayList();
        return ObjectType::staticMetaObject.method(m_methods[index + 1]).parameterNames();
    }
    const QByteArray typeName(int index) const override
    {
        switch (index) {
        case 0: return QByteArrayLiteral("QString");
        case 1: return QByteArrayLiteral("QMap<QString, QString>");
        case 2: return QByteArrayLiteral("int");
        }
        return QByteArrayLiteral("");
    }
    QByteArray objectSignature() const override { return QByteArray{"6591e428008fc9894ecd0b19856d06dc713ac608"}; }

    int m_enums[1];
    int m_properties[1];
    int m_signals[1];
    int m_methods[4];
    const QString m_name;
    int m_methodArgCount[3];
    const int* m_methodArgTypes[3];
};


#endif // REP_USERTYPES_MERGED_H
