#ifndef REP_SERVER_SOURCE_H
#define REP_SERVER_SOURCE_H

// This is an autogenerated file.
// Do not edit this file, any changes made will be lost the next time it is generated.

#include <QtCore/qobject.h>
#include <QtCore/qdatastream.h>
#include <QtCore/qvariant.h>
#include <QtCore/qmap.h>
#include <QtCore/qmetatype.h>

#include <QtRemoteObjects/qremoteobjectnode.h>
#include <QtRemoteObjects/qremoteobjectsource.h>


using namespace Qt::Literals::StringLiterals;

class TestEnum
{
    Q_GADGET
    TestEnum();

public:
    enum Test {
        TRUE = 0,
        FALSE = 1,
    };
    Q_ENUM(Test)
};

class TestChildClassSource : public QObject
{
    Q_OBJECT
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_TYPE, "TestChildClass")
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_SIGNATURE, "80c37e337ea46a89a8bdd13ee58e1791b28566de")
    Q_PROPERTY(int prop1 READ prop1 WRITE setProp1 NOTIFY prop1Changed)
    Q_PROPERTY(double prop2 READ prop2 WRITE setProp2 NOTIFY prop2Changed)

public:
    explicit TestChildClassSource(QObject *parent = nullptr) : QObject(parent)
    {
    }

public:
    ~TestChildClassSource() override = default;

    virtual int prop1() const = 0;
    virtual double prop2() const = 0;
    virtual void setProp1(int prop1) = 0;
    virtual void setProp2(double prop2) = 0;

Q_SIGNALS:
    void prop1Changed(int prop1);
    void prop2Changed(double prop2);

public Q_SLOTS:
    virtual void pushProp1(int prop1)
    {
        setProp1(prop1);
    }
    virtual void pushProp2(double prop2)
    {
        setProp2(prop2);
    }

private:
    friend class QT_PREPEND_NAMESPACE(QRemoteObjectNode);
};

class TestChildClassSimpleSource : public TestChildClassSource
{
    Q_OBJECT

public:
    explicit TestChildClassSimpleSource(QObject *parent = nullptr) : TestChildClassSource(parent)
    , m_prop1()
    , m_prop2()
    {
    }

public:
    ~TestChildClassSimpleSource() override = default;

    int prop1() const override { return m_prop1; }
    double prop2() const override { return m_prop2; }
    void setProp1(int prop1) override
    {
        if (prop1 != m_prop1) {
            m_prop1 = prop1;
            Q_EMIT prop1Changed(m_prop1);
        }
    }
    void setProp2(double prop2) override
    {
        if (prop2 != m_prop2) {
            m_prop2 = prop2;
            Q_EMIT prop2Changed(m_prop2);
        }
    }

private:
    int m_prop1;
    double m_prop2;
};

template <class ObjectType>
struct TestChildClassSourceAPI : public SourceApiMap
{
    TestChildClassSourceAPI(ObjectType *object, const QString &name = QLatin1String("TestChildClass"))
        : SourceApiMap(), m_name(name)
    {
        Q_UNUSED(object)
        m_enums[0] = 0;
        m_properties[0] = 2;
        m_properties[1] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::prop1, static_cast<int (QObject::*)()>(nullptr),"prop1");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::prop1Changed, static_cast<void (QObject::*)()>(nullptr));
        m_properties[2] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::prop2, static_cast<double (QObject::*)()>(nullptr),"prop2");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::prop2Changed, static_cast<void (QObject::*)()>(nullptr));
        m_signals[0] = 2;
        m_signals[1] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::prop1Changed, static_cast<void(QObject::*)(int)>(nullptr),m_signalArgCount+0,&m_signalArgTypes[0]);
        m_signals[2] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::prop2Changed, static_cast<void(QObject::*)(double)>(nullptr),m_signalArgCount+1,&m_signalArgTypes[1]);
        m_methods[0] = 2;
        m_methods[1] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::pushProp1, static_cast<void (QObject::*)(int)>(nullptr),"pushProp1(int)",m_methodArgCount+0,&m_methodArgTypes[0]);
        m_methods[2] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::pushProp2, static_cast<void (QObject::*)(double)>(nullptr),"pushProp2(double)",m_methodArgCount+1,&m_methodArgTypes[1]);
    }

    QString name() const override { return m_name; }
    QString typeName() const override { return QStringLiteral("TestChildClass"); }
    int enumCount() const override { return m_enums[0]; }
    int propertyCount() const override { return m_properties[0]; }
    int signalCount() const override { return m_signals[0]; }
    int methodCount() const override { return m_methods[0]; }
    int sourceEnumIndex(int index) const override
    {
        if (index < 0 || index >= m_enums[0] || index + 1 >= int(std::size(m_enums)))
            return -1;
        return m_enums[index+1];
    }
    int sourcePropertyIndex(int index) const override
    {
        if (index < 0 || index >= m_properties[0] || index + 1 >= int(std::size(m_properties)))
            return -1;
        return m_properties[index+1];
    }
    int sourceSignalIndex(int index) const override
    {
        if (index < 0 || index >= m_signals[0] || index + 1 >= int(std::size(m_signals)))
            return -1;
        return m_signals[index+1];
    }
    int sourceMethodIndex(int index) const override
    {
        if (index < 0 || index >= m_methods[0] || index + 1 >= int(std::size(m_methods)))
            return -1;
        return m_methods[index+1];
    }
    int signalParameterCount(int index) const override
    {
        if (index < 0 || index >= m_signals[0])
            return -1;
        return m_signalArgCount[index];
    }
    int signalParameterType(int sigIndex, int paramIndex) const override
    {
        if (sigIndex < 0 || sigIndex >= m_signals[0] || paramIndex < 0 || paramIndex >= m_signalArgCount[sigIndex])
            return -1;
        return m_signalArgTypes[sigIndex][paramIndex];
    }
    int methodParameterCount(int index) const override
    {
        if (index < 0 || index >= m_methods[0])
            return -1;
        return m_methodArgCount[index];
    }
    int methodParameterType(int methodIndex, int paramIndex) const override
    {
        if (methodIndex < 0 || methodIndex >= m_methods[0] || paramIndex < 0 || paramIndex >= m_methodArgCount[methodIndex])
            return -1;
        return m_methodArgTypes[methodIndex][paramIndex];
    }
    int propertyIndexFromSignal(int index) const override
    {
        switch (index) {
        case 0: return m_properties[1];
        case 1: return m_properties[2];
        }
        return -1;
    }
    int propertyRawIndexFromSignal(int index) const override
    {
        switch (index) {
        case 0: return 0;
        case 1: return 1;
        }
        return -1;
    }
    const QByteArray signalSignature(int index) const override
    {
        switch (index) {
        case 0: return QByteArrayLiteral("prop1Changed(int)");
        case 1: return QByteArrayLiteral("prop2Changed(double)");
        }
        return QByteArrayLiteral("");
    }
    QByteArrayList signalParameterNames(int index) const override
    {
        if (index < 0 || index >= m_signals[0] || index + 1 >= int(std::size(m_signals)))
            return QByteArrayList();
        return ObjectType::staticMetaObject.method(m_signals[index + 1]).parameterNames();
    }
    const QByteArray methodSignature(int index) const override
    {
        switch (index) {
        case 0: return QByteArrayLiteral("pushProp1(int)");
        case 1: return QByteArrayLiteral("pushProp2(double)");
        }
        return QByteArrayLiteral("");
    }
    QMetaMethod::MethodType methodType(int) const override
    {
        return QMetaMethod::Slot;
    }
    QByteArrayList methodParameterNames(int index) const override
    {
        if (index < 0 || index >= m_methods[0] || index + 1 >= int(std::size(m_methods)))
            return QByteArrayList();
        return ObjectType::staticMetaObject.method(m_methods[index + 1]).parameterNames();
    }
    const QByteArray typeName(int index) const override
    {
        switch (index) {
        case 0: return QByteArrayLiteral("void");
        case 1: return QByteArrayLiteral("void");
        }
        return QByteArrayLiteral("");
    }
    QByteArray objectSignature() const override { return QByteArray{"80c37e337ea46a89a8bdd13ee58e1791b28566de"}; }

    int m_enums[1];
    int m_properties[3];
    int m_signals[3];
    int m_methods[3];
    const QString m_name;
    int m_signalArgCount[2];
    const int* m_signalArgTypes[2];
    int m_methodArgCount[2];
    const int* m_methodArgTypes[2];
};

class TestClassSource : public QObject
{
    Q_OBJECT
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_TYPE, "TestClass")
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_SIGNATURE, "55fb1374e101d50f979868937f54b3a0f9dcc85e")
    Q_PROPERTY(TestEnum::Test testEnum READ testEnum WRITE setTestEnum NOTIFY testEnumChanged)
    Q_PROPERTY(ClassEnum classEnum READ classEnum WRITE setClassEnum NOTIFY classEnumChanged)
    Q_PROPERTY(int prop1 READ prop1 WRITE setProp1 NOTIFY prop1Changed)
    Q_PROPERTY(double prop2 READ prop2 WRITE setProp2 NOTIFY prop2Changed)
    Q_PROPERTY(TestChildClassSource* childProp READ childProp WRITE setChildProp NOTIFY childPropChanged)

public:
    enum ClassEnum {
        Null = 0,
        One = 1,
        Two = 2,
    };
    Q_ENUM(ClassEnum)

public:
    explicit TestClassSource(QObject *parent = nullptr) : QObject(parent)
    {
        qRegisterMetaType<ClassEnum>();
        qRegisterMetaType<TestEnum::Test>();

    }

public:
    ~TestClassSource() override = default;

    virtual TestEnum::Test testEnum() const = 0;
    virtual ClassEnum classEnum() const = 0;
    virtual int prop1() const = 0;
    virtual double prop2() const = 0;
    virtual TestChildClassSource* childProp() const = 0;
    virtual void setTestEnum(TestEnum::Test testEnum) = 0;
    virtual void setClassEnum(ClassEnum classEnum) = 0;
    virtual void setProp1(int prop1) = 0;
    virtual void setProp2(double prop2) = 0;
    virtual void setChildProp(TestChildClassSource* childProp) = 0;

Q_SIGNALS:
    void testEnumChanged(TestEnum::Test testEnum);
    void classEnumChanged(TestClassSource::ClassEnum classEnum);
    void prop1Changed(int prop1);
    void prop2Changed(double prop2);
    void childPropChanged(TestChildClassSource* childProp);
    void signal1();
    void signal2();
    void pong(const QString & message);

public Q_SLOTS:
    virtual void pushTestEnum(TestEnum::Test testEnum)
    {
        setTestEnum(testEnum);
    }
    virtual void pushClassEnum(TestClassSource::ClassEnum classEnum)
    {
        setClassEnum(classEnum);
    }
    virtual void pushProp1(int prop1)
    {
        setProp1(prop1);
    }
    virtual void pushProp2(double prop2)
    {
        setProp2(prop2);
    }
    virtual bool slot1() = 0;
    virtual QString slot2() = 0;
    virtual void ping(const QString & message) = 0;
    virtual bool quit() = 0;

private:
    friend class QT_PREPEND_NAMESPACE(QRemoteObjectNode);
};

class TestClassSimpleSource : public TestClassSource
{
    Q_OBJECT

public:
    explicit TestClassSimpleSource(QObject *parent = nullptr) : TestClassSource(parent)
    , m_testEnum()
    , m_classEnum()
    , m_prop1()
    , m_prop2()
    , m_childProp(nullptr)
    {
    }

public:
    ~TestClassSimpleSource() override = default;

    TestEnum::Test testEnum() const override { return m_testEnum; }
    ClassEnum classEnum() const override { return m_classEnum; }
    int prop1() const override { return m_prop1; }
    double prop2() const override { return m_prop2; }
    TestChildClassSource* childProp() const override { return m_childProp; }
    void setTestEnum(TestEnum::Test testEnum) override
    {
        if (testEnum != m_testEnum) {
            m_testEnum = testEnum;
            Q_EMIT testEnumChanged(m_testEnum);
        }
    }
    void setClassEnum(ClassEnum classEnum) override
    {
        if (classEnum != m_classEnum) {
            m_classEnum = classEnum;
            Q_EMIT classEnumChanged(m_classEnum);
        }
    }
    void setProp1(int prop1) override
    {
        if (prop1 != m_prop1) {
            m_prop1 = prop1;
            Q_EMIT prop1Changed(m_prop1);
        }
    }
    void setProp2(double prop2) override
    {
        if (prop2 != m_prop2) {
            m_prop2 = prop2;
            Q_EMIT prop2Changed(m_prop2);
        }
    }
    void setChildProp(TestChildClassSource* childProp) override
    {
        if (childProp != m_childProp) {
            m_childProp = childProp;
            Q_EMIT childPropChanged(m_childProp);
        }
    }

private:
    TestEnum::Test m_testEnum;
    ClassEnum m_classEnum;
    int m_prop1;
    double m_prop2;
    TestChildClassSource* m_childProp;
};

template <class ObjectType>
struct TestClassSourceAPI : public SourceApiMap
{
    // You need to add this enum as well as Q_ENUM to your
    // QObject class in order to use .rep enums over QtRO for
    // non-repc generated QObjects.
    enum ClassEnum {
        Null = 0,
        One = 1,
        Two = 2,
    };
    TestClassSourceAPI(ObjectType *object, const QString &name = QLatin1String("TestClass"))
        : SourceApiMap(), m_name(name)
    {
        using childProp_type_t = typename std::remove_pointer<decltype(object->childProp())>::type;
        m_enums[0] = 1;
        m_enums[1] = ObjectType::staticMetaObject.indexOfEnumerator("ClassEnum");
        m_properties[0] = 5;
        m_properties[1] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::testEnum, static_cast<TestEnum::Test (QObject::*)()>(nullptr),"testEnum");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::testEnumChanged, static_cast<void (QObject::*)()>(nullptr));
        m_properties[2] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::classEnum, static_cast<typename ObjectType::ClassEnum (QObject::*)()>(nullptr),"classEnum");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::classEnumChanged, static_cast<void (QObject::*)()>(nullptr));
        m_properties[3] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::prop1, static_cast<int (QObject::*)()>(nullptr),"prop1");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::prop1Changed, static_cast<void (QObject::*)()>(nullptr));
        m_properties[4] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::prop2, static_cast<double (QObject::*)()>(nullptr),"prop2");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::prop2Changed, static_cast<void (QObject::*)()>(nullptr));
        m_properties[5] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::childProp, static_cast<TestChildClassSource* (QObject::*)()>(nullptr),"childProp");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::childPropChanged, static_cast<void (QObject::*)()>(nullptr));
        m_signals[0] = 8;
        m_signals[1] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::testEnumChanged, static_cast<void(QObject::*)(TestEnum::Test)>(nullptr),m_signalArgCount+0,&m_signalArgTypes[0]);
        m_signals[2] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::classEnumChanged, static_cast<void(QObject::*)(typename ObjectType::ClassEnum)>(nullptr),m_signalArgCount+1,&m_signalArgTypes[1]);
        m_signals[3] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::prop1Changed, static_cast<void(QObject::*)(int)>(nullptr),m_signalArgCount+2,&m_signalArgTypes[2]);
        m_signals[4] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::prop2Changed, static_cast<void(QObject::*)(double)>(nullptr),m_signalArgCount+3,&m_signalArgTypes[3]);
        m_signals[5] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::childPropChanged, static_cast<void(QObject::*)(TestChildClassSource*)>(nullptr),m_signalArgCount+4,&m_signalArgTypes[4]);
        m_signals[6] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::signal1, static_cast<void (QObject::*)()>(nullptr),m_signalArgCount+5,&m_signalArgTypes[5]);
        m_signals[7] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::signal2, static_cast<void (QObject::*)()>(nullptr),m_signalArgCount+6,&m_signalArgTypes[6]);
        m_signals[8] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::pong, static_cast<void (QObject::*)(QString)>(nullptr),m_signalArgCount+7,&m_signalArgTypes[7]);
        m_methods[0] = 8;
        m_methods[1] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::pushTestEnum, static_cast<void (QObject::*)(TestEnum::Test)>(nullptr),"pushTestEnum(TestEnum::Test)",m_methodArgCount+0,&m_methodArgTypes[0]);
        m_methods[2] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::pushClassEnum, static_cast<void (QObject::*)(typename ObjectType::ClassEnum)>(nullptr),"pushClassEnum(ClassEnum)",m_methodArgCount+1,&m_methodArgTypes[1]);
        m_methods[3] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::pushProp1, static_cast<void (QObject::*)(int)>(nullptr),"pushProp1(int)",m_methodArgCount+2,&m_methodArgTypes[2]);
        m_methods[4] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::pushProp2, static_cast<void (QObject::*)(double)>(nullptr),"pushProp2(double)",m_methodArgCount+3,&m_methodArgTypes[3]);
        m_methods[5] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::slot1, static_cast<void (QObject::*)()>(nullptr),"slot1()",m_methodArgCount+4,&m_methodArgTypes[4]);
        m_methods[6] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::slot2, static_cast<void (QObject::*)()>(nullptr),"slot2()",m_methodArgCount+5,&m_methodArgTypes[5]);
        m_methods[7] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::ping, static_cast<void (QObject::*)(QString)>(nullptr),"ping(QString)",m_methodArgCount+6,&m_methodArgTypes[6]);
        m_methods[8] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::quit, static_cast<void (QObject::*)()>(nullptr),"quit()",m_methodArgCount+7,&m_methodArgTypes[7]);
        m_subclasses << new TestChildClassSourceAPI<childProp_type_t>(object->childProp(), QStringLiteral("childProp"));
    }

    QString name() const override { return m_name; }
    QString typeName() const override { return QStringLiteral("TestClass"); }
    int enumCount() const override { return m_enums[0]; }
    int propertyCount() const override { return m_properties[0]; }
    int signalCount() const override { return m_signals[0]; }
    int methodCount() const override { return m_methods[0]; }
    int sourceEnumIndex(int index) const override
    {
        if (index < 0 || index >= m_enums[0] || index + 1 >= int(std::size(m_enums)))
            return -1;
        return m_enums[index+1];
    }
    int sourcePropertyIndex(int index) const override
    {
        if (index < 0 || index >= m_properties[0] || index + 1 >= int(std::size(m_properties)))
            return -1;
        return m_properties[index+1];
    }
    int sourceSignalIndex(int index) const override
    {
        if (index < 0 || index >= m_signals[0] || index + 1 >= int(std::size(m_signals)))
            return -1;
        return m_signals[index+1];
    }
    int sourceMethodIndex(int index) const override
    {
        if (index < 0 || index >= m_methods[0] || index + 1 >= int(std::size(m_methods)))
            return -1;
        return m_methods[index+1];
    }
    int signalParameterCount(int index) const override
    {
        if (index < 0 || index >= m_signals[0])
            return -1;
        return m_signalArgCount[index];
    }
    int signalParameterType(int sigIndex, int paramIndex) const override
    {
        if (sigIndex < 0 || sigIndex >= m_signals[0] || paramIndex < 0 || paramIndex >= m_signalArgCount[sigIndex])
            return -1;
        return m_signalArgTypes[sigIndex][paramIndex];
    }
    int methodParameterCount(int index) const override
    {
        if (index < 0 || index >= m_methods[0])
            return -1;
        return m_methodArgCount[index];
    }
    int methodParameterType(int methodIndex, int paramIndex) const override
    {
        if (methodIndex < 0 || methodIndex >= m_methods[0] || paramIndex < 0 || paramIndex >= m_methodArgCount[methodIndex])
            return -1;
        return m_methodArgTypes[methodIndex][paramIndex];
    }
    int propertyIndexFromSignal(int index) const override
    {
        switch (index) {
        case 0: return m_properties[1];
        case 1: return m_properties[2];
        case 2: return m_properties[3];
        case 3: return m_properties[4];
        case 4: return m_properties[5];
        }
        return -1;
    }
    int propertyRawIndexFromSignal(int index) const override
    {
        switch (index) {
        case 0: return 0;
        case 1: return 1;
        case 2: return 2;
        case 3: return 3;
        case 4: return 4;
        }
        return -1;
    }
    const QByteArray signalSignature(int index) const override
    {
        switch (index) {
        case 0: return QByteArrayLiteral("testEnumChanged(TestEnum::Test)");
        case 1: return QByteArrayLiteral("classEnumChanged($1)").replace("$1", QtPrivate::qtro_enum_signature<ObjectType>("ClassEnum"));
        case 2: return QByteArrayLiteral("prop1Changed(int)");
        case 3: return QByteArrayLiteral("prop2Changed(double)");
        case 4: return QByteArrayLiteral("childPropChanged(TestChildClassSource*)");
        case 5: return QByteArrayLiteral("signal1()");
        case 6: return QByteArrayLiteral("signal2()");
        case 7: return QByteArrayLiteral("pong(QString)");
        }
        return QByteArrayLiteral("");
    }
    QByteArrayList signalParameterNames(int index) const override
    {
        if (index < 0 || index >= m_signals[0] || index + 1 >= int(std::size(m_signals)))
            return QByteArrayList();
        return ObjectType::staticMetaObject.method(m_signals[index + 1]).parameterNames();
    }
    const QByteArray methodSignature(int index) const override
    {
        switch (index) {
        case 0: return QByteArrayLiteral("pushTestEnum(TestEnum::Test)");
        case 1: return QByteArrayLiteral("pushclassEnum($1)").replace("$1", QtPrivate::qtro_enum_signature<ObjectType>("ClassEnum"));
        case 2: return QByteArrayLiteral("pushProp1(int)");
        case 3: return QByteArrayLiteral("pushProp2(double)");
        case 4: return QByteArrayLiteral("slot1()");
        case 5: return QByteArrayLiteral("slot2()");
        case 6: return QByteArrayLiteral("ping(QString)");
        case 7: return QByteArrayLiteral("quit()");
        }
        return QByteArrayLiteral("");
    }
    QMetaMethod::MethodType methodType(int) const override
    {
        return QMetaMethod::Slot;
    }
    QByteArrayList methodParameterNames(int index) const override
    {
        if (index < 0 || index >= m_methods[0] || index + 1 >= int(std::size(m_methods)))
            return QByteArrayList();
        return ObjectType::staticMetaObject.method(m_methods[index + 1]).parameterNames();
    }
    const QByteArray typeName(int index) const override
    {
        switch (index) {
        case 0: return QByteArrayLiteral("void");
        case 1: return QByteArrayLiteral("void");
        case 2: return QByteArrayLiteral("void");
        case 3: return QByteArrayLiteral("void");
        case 4: return QByteArrayLiteral("bool");
        case 5: return QByteArrayLiteral("QString");
        case 6: return QByteArrayLiteral("void");
        case 7: return QByteArrayLiteral("bool");
        }
        return QByteArrayLiteral("");
    }
    QByteArray objectSignature() const override { return QByteArray{"55fb1374e101d50f979868937f54b3a0f9dcc85e"}; }

    int m_enums[2];
    int m_properties[6];
    int m_signals[9];
    int m_methods[9];
    const QString m_name;
    int m_signalArgCount[8];
    const int* m_signalArgTypes[8];
    int m_methodArgCount[8];
    const int* m_methodArgTypes[8];
};


#endif // REP_SERVER_SOURCE_H
